////////////// includes
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>              
#include <sys/timeb.h>
#include <dos.h>
#include <dir.h>
// directx
#include <initguid.h>
#define D3D_OVERLOADS
#include <ddraw.h>
#include <d3d.h>
#include <mmsystem.h>
#include <dsound.h>


/////////////// defs
// graphics
#define XRES 640
#define YRES 480
#define BITS 16 // Auch in EnumDeviceCallback ndern!
#define VIEWDIV 8
#define MAXHEIGHT 4
#define FIELDX 256//256
#define FIELDY 256//256
#define TEXX 8 // Anz der Tex's in X-Richtung
#define TEXY 8
#define TXRES 256//32//256 // Anz der Texel in einer Textur
#define TYRES 256//32//256
#define FXRES (TXRES*TEXX/FIELDX) // Anz der Texel in X-Richtung pro Feld
#define FYRES (TYRES*TEXY/FIELDY)
#define TEXSPACEOFF 17 // OFFSET der terrain-Texturen im Textur-array
#define TREESPACEOFF 13
#define TEXTSPACEOFF 8
#define ORDERLINES 10
#define TEXTOPACITY 128
#define LEFTEND -15
#define RIGHTEND 16
#define TOPEND 22
#define BOTTOMEND -19
#define DISPLAYEDMISSIONS 8
#define TERRAWAYS 20
#define STRINGLEN 80
#define MAXLIGHTS 5
// dx
#define STDCOMPFUNC D3DCMP_LESSEQUAL
#define ZBCLEARVALUE 1
#define ZMULT 0.4//0.5
#define ZADD 0.9
#define VIEWPORTMINZ 0.0f
#define VIEWPORTMAXZ 1.0f
#define SOUNDS 4
#define PARSOUNDS 40
// game
#define OMILS 100
#define TREES 512
#define NUMSHOTS OMILS*20
#define OMILTYPES 8
#define OBJECTS OMILTYPES*4
#define PARTICLES 500
#define EXPPARTS 2
#define SHOTGRAVITY 2
#define PARTICLELIFE 12
#define PARTICLELIFE3 4
#define EXPLFIRE 0.25
#define EXPLFULLSMOKEBEGIN 0.15
#define EXPLFULLSMOKEEND 0.4
#define EXPSIZE 5
#define MARSRANGE 0.7
// gameplay
#define TANKSPEED 4
#define SHOTSPEED 8
#define TURNSPEED 4
#define TURRETTURNSPEED 3
#define TANKHITPOINTS0 100
#define TANKHITPOINTS1 60
#define GROUPATTACKDST 16
#define GROUPATTACKNUM 4
// math
#define PI 3.141592654
// debug
//#define DEBUG
#define PROFILER
//#define DISABLESOUND
#define DISABLESHOTLIGHTING
#define USERVIS
#define USERVISNUM 2
#define PROFILERNUM 13
#ifdef DEBUG
#define status(x) statusreal((x))
#endif
#ifndef DEBUG
#define status(x)
#endif
// dx
#define PARTLIGHTOFFSET 20
#define SHOTLIGHTOFFSET 20+PARTICLES
///////////////// funcs
#define RELEASE(x) if (x) { (x)->Release(); (x)=NULL; }
// normals
#define DXXRESULT(a,b,c) -((a.y-b.y)*(c.z-b.z)-(a.z-b.z)*(c.y-b.y))
#define DXYRESULT(a,b,c) -((a.z-b.z)*(c.x-b.x)-(a.x-b.x)*(c.z-b.z))
#define DXZRESULT(a,b,c) -((a.x-b.x)*(c.y-b.y)-(a.y-b.y)*(c.x-b.x))
#define DXNORM(a,b,c) dxfix(DXXRESULT(a,b,c),DXYRESULT(a,b,c),DXZRESULT(a,b,c))


////////////// structs
// dx objects
struct dxtriangle {
  long num;
  D3DVERTEX* v;
  unsigned tex;
};

struct dx3dobject {
  long lists, strips, fans;
  dxtriangle *list, *strip, *fan;
} obj[OBJECTS];

// objects
struct tparticle {
  float x, y, z, dz;
  float t, size;
  int typ;
  bool used;
  bool lit;
//  int lightid;
//  LPDIRECT3DLIGHT light;
} part[PARTICLES];

struct tway {
  float x1, y1, x2, y2;
  bool used;
};

// terrain
struct tterrain {
  unsigned char hmap[FIELDX][FIELDY];
//  D3DVECTOR norm[FIELDX][FIELDY];
  D3DVERTEX vtx[FIELDX][FIELDY][4];
  unsigned char tex[FIELDX][FIELDY];
  int ways;
  tway way[TERRAWAYS];
}terra;

struct tmildsc {
  float maxspeed, shotspeed, size, range, shothit, hitpoints, shotfreq;
} mildsc[OMILTYPES];

struct mil {
  float x, y, z, a, b, c, tb, sp, da, tdx, tdy, tdz, ta;
  float sx, sy; // screen coordinates
  float targetx, targety; // ki target coordinates
  char owner;
  int target, ttarget;
  float hit, maxhit;
  int typ;
  float lastfoot, lastshot;
  bool used, selected, hitting, dead;
} omil[OMILS];

struct ttree {
  float x, y, z, a, b;
  char typ;
  bool used, falling;
} tree[TREES];

struct tshot{
  bool used;
  float x, y, z;
  float dx,dy,dz;
  float t, split;
  float lastsmoke;
  int typ;
  int owner, tank;
//  LPDIRECT3DLIGHT light;
} shot[NUMSHOTS];

// resources for game structs
struct tomildesc {
  float posx, posy, targetx, targety;
  int typ, target;
  unsigned char owner;
};

// game structs
struct tspeed {
  float t;// time of last frame
  float c;// speed constant
  float g;// game time
  int cnt;
} gs;

struct tview {
  float px, py, zoom;// scroll
  bool menu, timemenu;
  int menutype, menuscroll, menumaxscroll;
  float menukilltime;
  char mfnames[DISPLAYEDMISSIONS][STRINGLEN];
} view;

struct tmouse {
  bool down, up, rdown;
  int downx, downy;
} mouse;

struct tmissionlight {
  float x,y,z;
  float r,g,b;
};

struct tgoal {
  int survive, kill;
  bool killall, location, killlocation, ban;
  float gotox, gotoy, radius;
  float killx, killy, killradius;
  float banx, bany, banradius;
};

struct tmission {
  char name[STRINGLEN];
  char fname[STRINGLEN];
  char next[STRINGLEN];
  char orders[ORDERLINES][STRINGLEN];
  int numomil, namelen, orderlen[ORDERLINES], nextlen;
  tgoal goal;
  tomildesc* omildesc;
  bool success, done;
  tmissionlight light[2];
} mission;

struct tstats {
  float uservis[USERVISNUM];
  float profiler[PROFILERNUM];
  float pstart[PROFILERNUM];
  float ptime[PROFILERNUM];
} stats;

///////////////// vars
// windows
HWND hwnd;
MSG messages;
WNDCLASS wincl; 
BOOL bQuit=FALSE;
char szClassName[ ] = "WindowsApp";
// dx
LPDIRECTDRAW7 dxdd;
DDSURFACEDESC2 dxsd;
D3DVIEWPORT7 dxviewport;
LPDIRECTDRAWSURFACE7 dxprimary = NULL;
LPDIRECTDRAWSURFACE7 dxbackbuffer = NULL;
LPDIRECTDRAWSURFACE7 dxzbuffer = NULL;
LPDIRECT3D7 dxd3d = NULL;
LPDIRECT3DDEVICE7 dxd3ddevice = NULL;
LPDIRECT3DVIEWPORT3 dxd3dviewport = NULL;
DDBLTFX dxblt;
GUID dxhwguid, dxrgbguid;
bool dxhwfound, dxrgbfound;
// lighting
LPDIRECT3DLIGHT dxd3dlight;
D3DLIGHT7 dxlight;
LPDIRECT3DMATERIAL3 dxd3dmat;
D3DMATERIAL7 dxmat;
D3DMATERIALHANDLE dxhmat;
//bool lightused[MAXLIGHTS];
// texturing
LPDIRECTDRAWSURFACE7 dxstexture[TEXSPACEOFF+TEXX*TEXY];
LPDIRECT3DTEXTURE2 dxtexture;
HDC dxtexturedc, dxtexturedc2;
unsigned int dxtexr;
unsigned int dxtexg;
unsigned int dxtexb;
unsigned int dxtexalpha;
unsigned int dxttexr;
unsigned int dxttexg;
unsigned int dxttexb;
unsigned int dxttexredr;
unsigned int dxttexred1;
unsigned int dxttexgreenr;
unsigned int dxttexgreen1;
unsigned int dxttexbluer;
unsigned int dxttexblue1;
unsigned int dxxtexalphar;
unsigned int dxxtexalpha1;
unsigned int dxxtexredr;
unsigned int dxxtexred1;
unsigned int dxxtexgreenr;
unsigned int dxxtexgreen1;
unsigned int dxxtexbluer;
unsigned int dxxtexblue1;
// transforming
D3DMATRIX matrix, viewmtx, projmtx;
// zbuffer
long dxzbits=0;
// sound
LPDIRECTSOUND dxsound;
LPDIRECTSOUNDBUFFER dxsoundbuffer[SOUNDS*PARSOUNDS];


//////////// prototypes
LRESULT CALLBACK WindowProcedure(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam);


//////////// procedures + functions

D3DVECTOR dxfix(float x, float y, float z){
  float len=sqrt(x*x+y*y+z*z);
  D3DVECTOR v=D3DVECTOR(x/len, y/len, z/len);
  return v;
}

void statusreal(long s){
  FILE *f;
  f=fopen("status.txt", "w");
  fseek(f, 0, SEEK_SET);
  fwrite( &s, sizeof(s), 1, f);
  fclose(f);
}

void startprofile(int n){
  struct timeb t2;
  ftime(&t2);
  stats.pstart[n]=0.001*(1000*t2.time+t2.millitm);
}

void stopprofile(int n){
  struct timeb t2;
  ftime(&t2);
//  stats.ptime[n]=(249.0*stats.ptime[n]+(0.001*(1000*t2.time+t2.millitm)-stats.pstart[n]))/250.0;
  stats.ptime[n]+=(0.001*(1000*t2.time+t2.millitm)-stats.pstart[n]);
}

void mapply(D3DVECTOR* v, D3DMATRIX mo){
  D3DMATRIX m=mo;
  D3DVECTOR r;
  // apply
  r.x=v->x*m(0, 0)+v->y*m(1, 0)+v->z*m(2, 0);
  r.y=v->x*m(0, 1)+v->y*m(1, 1)+v->z*m(2, 1);
  r.z=v->x*m(0, 2)+v->y*m(1, 2)+v->z*m(2, 2);
  // move
  r.x+=m(3, 0);
  r.y+=m(3, 1);
  r.z+=m(3, 2);
  // scale
  m(3, 3)+=v->x*m(0, 3);
  m(3, 3)+=v->y*m(1, 3);
  m(3, 3)+=v->z*m(2, 3);
  if(m(3, 3)!=0.0f){
    r.x/=m(3, 3);
    r.y/=m(3, 3);
    r.z/=m(3, 3);
  }
  *v=r;
}

float absf(float x){
  if(x>=0){
    return x;
  } else {
    x=-x;
    return x;
  }  
}

void dxloadobject(dx3dobject* obj, char* fname){
  status(800);
  FILE *f;
  unsigned short typ;
  float scalex=0, scaley=0, scalez=0, fl=0;
  D3DVECTOR v[3];
  float tu[3], tv[3];
  status(801);
  obj->lists=obj->strips=obj->fans=0;
  obj->list=NULL;
  obj->strip=NULL;
  obj->fan=NULL;
  status(802);
  f=fopen(fname, "rb");
  fseek(f, 0, SEEK_END);
  int size=ftell(f);
  fseek(f, 0, SEEK_SET);
  status(803);
  while(/*!feof(f)*/ftell(f)<size){
    status(804);
    fread(&typ, 2, 1, f);
    status(805);
    if(typ==0){
      fread(&scalex, 4, 1, f);
      fread(&scaley, 4, 1, f);
      fread(&scalez, 4, 1, f);
    }
    status(806);
    if(typ==1){
      status(820);
      obj->lists++;
      if(obj->list==NULL){
        obj->list=(dxtriangle*)malloc(obj->lists*sizeof(dxtriangle));
      } else {
        obj->list=(dxtriangle*)realloc(obj->list, obj->lists*sizeof(dxtriangle));
      }
      status(821);
      fread(&fl, 4, 1, f);obj->list[obj->lists-1].num=(long)fl;
      fread(&fl, 4, 1, f);obj->list[obj->lists-1].tex=(unsigned)fl;
      status(822);
      obj->list[obj->lists-1].v=(D3DVERTEX*)malloc(obj->list[obj->lists-1].num*sizeof(D3DVERTEX));
      status(823);
      for(int i=0;i<obj->list[obj->lists-1].num/3;i++){
        status(824);
        for(int j=0;j<3;j++){
          fread(&fl, 4, 1, f);v[j].x=scalex*fl;
          fread(&fl, 4, 1, f);v[j].y=scaley*fl;
          fread(&fl, 4, 1, f);v[j].z=scalez*fl;
          fread(&tu[j], 4, 1, f);
          fread(&tv[j], 4, 1, f);
        }
        status(825);
        for(int j=0;j<3;j++){
          obj->list[obj->lists-1].v[i*3+j]=D3DVERTEX(v[j], DXNORM(v[0], v[1], v[2]),tu[j], tv[j]);
        }  
        status(826);
      }
    }
    status(807);
    if(typ==2){
      obj->strips++;
      if(obj->strip==NULL){
        obj->strip=(dxtriangle*)malloc(obj->strips*sizeof(dxtriangle));
      } else {
        obj->strip=(dxtriangle*)realloc(obj->strip, obj->strips*sizeof(dxtriangle));
      }
      fread(&fl, 4, 1, f);obj->strip[obj->strips-1].num=(long)fl;
      fread(&fl, 4, 1, f);obj->strip[obj->strips-1].tex=(unsigned)fl;
      obj->strip[obj->strips-1].v=(D3DVERTEX*)malloc(obj->strip[obj->strips-1].num*sizeof(D3DVERTEX));
      // first 3
      for(int i=0;i<3;i++){
        fread(&fl, 4, 1, f);v[i].x=scalex*fl;
        fread(&fl, 4, 1, f);v[i].y=scaley*fl;
        fread(&fl, 4, 1, f);v[i].z=scalez*fl;
        fread(&tu[i], 4, 1, f);
        fread(&tv[i], 4, 1, f);
      }
      for(int i=0;i<3;i++){
        obj->strip[obj->strips-1].v[i]=D3DVERTEX(v[i], DXNORM(v[0], v[1], v[2]),tu[i], tv[i]);
      }  
      if(obj->strip[obj->strips-1].num>3){
        for(int i=3;i<obj->strip[obj->strips-1].num;i++){
          fread(&fl, 4, 1, f);v[(i-3)%3].x=scalex*fl;
          fread(&fl, 4, 1, f);v[(i-3)%3].y=scaley*fl;
          fread(&fl, 4, 1, f);v[(i-3)%3].z=scalez*fl;
          fread(&tu[(i-3)%3], 4, 1, f);
          fread(&tv[(i-3)%3], 4, 1, f);
          if(i%2==0){
            obj->strip[obj->strips-1].v[i]=D3DVERTEX(v[(i-3)%3], DXNORM(v[0], v[1], v[2]),tu[(i-3)%3], tv[(i-3)%3]);
          } else {
            obj->strip[obj->strips-1].v[i]=D3DVERTEX(v[(i-3)%3], DXNORM(v[1], v[0], v[2]),tu[(i-3)%3], tv[(i-3)%3]);
          }
        }
      }
    }
    status(808);
  }
  status(809);
  fclose(f);
  status(810);
}

void dxcleanup(void){
  if (dxd3ddevice && dxd3dviewport){
//    dxd3ddevice->DeleteViewport(dxd3dviewport);
  }
  RELEASE(dxd3dviewport);
  RELEASE(dxd3ddevice);
  RELEASE(dxd3d);
  RELEASE(dxprimary);
  RELEASE(dxdd);
}

void dxerror(void){
  dxcleanup();
  DestroyWindow(hwnd);
  exit(0);
}

void winerror(void){
  DestroyWindow(hwnd);
  exit(0);
}

int begr(int x, int ber){
  if(ber>0){
    while(x<0)x+=ber;
    while(x>=ber)x-=ber;
    return x;
  }else{
    return 0;
  }
}

void play(int num){
#ifndef DISABLESOUND
  DWORD WAVStatus;
  for(int i=0;i<PARSOUNDS;i++){
    dxsoundbuffer[num*PARSOUNDS+i]->GetStatus(&WAVStatus);
    if(WAVStatus!=DSBSTATUS_PLAYING){
      dxsoundbuffer[num*PARSOUNDS+i]->Play(0,0,0);
      break;
    }
  }
#endif
}

HRESULT CALLBACK TerraTextureSearchCallback( DDPIXELFORMAT* pddpf, VOID* param )
{
    if(pddpf->dwRBitMask>=dxttexr&&pddpf->dwRBitMask<=0xFF0000
      &&pddpf->dwGBitMask>=dxttexg&&pddpf->dwGBitMask<=0xFF00
      &&pddpf->dwBBitMask>=dxttexb&&pddpf->dwBBitMask<=0xFF){
        memcpy( param, pddpf, sizeof(DDPIXELFORMAT) );
        dxttexr=pddpf->dwRBitMask;
        dxttexg=pddpf->dwGBitMask;
        dxttexb=pddpf->dwBBitMask;
        return DDENUMRET_OK;
    }
    return DDENUMRET_OK;
}

void initgreen(void){
  for(int i=0;i<TEXX;i++){
    for(int j=0;j<TEXY;j++){
      dxsd.dwSize=sizeof(DDSURFACEDESC2);
      dxstexture[TEXSPACEOFF+j*TEXX+i]->GetSurfaceDesc( &dxsd );
      dxstexture[TEXSPACEOFF+j*TEXX+i]->Lock( NULL, &dxsd, DDLOCK_WAIT, 0 );
      int dsize=dxsd.ddpfPixelFormat.dwRGBBitCount;
//      status(dsize);dxerror();
      unsigned int *texbuf=(unsigned int*)dxsd.lpSurface;
      unsigned short *texbufw=(unsigned short*)dxsd.lpSurface;
      if(dxsd.lpSurface==NULL){status(700);dxerror();}
//      dxstexture[TEXSPACEOFF+j*8+i]->GetDC(&dxtexturedc);
      status(503);
      for(int k=0;k<TXRES;k++){
        for(int l=0;l<TYRES;l++){
          if(dsize==16){
            texbufw[l*TXRES+k]=dxttexgreen1*(unsigned short)(dxttexgreenr*((float)(128+rand()%128)/255.0));
          } else{
            texbuf[l*TXRES+k]=dxttexgreen1*(unsigned int)(dxttexgreenr*((float)(128+rand()%128)/255.0));
          }
//          SetPixel(dxtexturedc, k, l, (256)*(128+rand()%128));
        }
      }    
      status(504);
      dxstexture[TEXSPACEOFF+j*TEXX+i]->Unlock(0);
//      dxstexture[TEXSPACEOFF+j*TEXX+i]->ReleaseDC(dxtexturedc);
      status(505);
//      if(dxstexture[j*8+i]->QueryInterface(IID_IDirect3DTexture2, (LPVOID *)&dxtexture) != S_OK) dxerror();
//      dxtexture->GetHandle(dxd3ddevice, (DWORD*)&dxhtexture[TEXSPACEOFF+j*TEXX+i]);
//      dxtexture->Release();
    }
  }
  status(1200);
  unsigned int color;
  unsigned short colorw;
  DDSURFACEDESC2 dxsd2;
  status(1201);
  for(int i=0;i<TEXX;i++){
    for(int j=0;j<TEXY;j++){
      for(int k=0;k<TXRES;k++){
        if(i==0&&j==0&&k==0)status(1202);
//        dxstexture[TEXSPACEOFF+j*TEXX+i]->GetDC(&dxtexturedc);
        dxsd.dwSize=sizeof(DDSURFACEDESC2);
        if(i==0&&j==0&&k==0)status(1203);
        dxstexture[TEXSPACEOFF+j*TEXX+i]->GetSurfaceDesc( &dxsd );
        if(i==0&&j==0&&k==0)status(1204);
        dxstexture[TEXSPACEOFF+j*TEXX+i]->Lock( NULL, &dxsd, DDLOCK_WAIT, 0 );
        if(i==0&&j==0&&k==0)status(1205);
        int dsize=dxsd.ddpfPixelFormat.dwRGBBitCount;
        unsigned int *texbuf=(unsigned int*)dxsd.lpSurface;
        unsigned short *texbufw=(unsigned short*)dxsd.lpSurface;
        if(i==0&&j==0&&k==0)status(1206);
        if(dxsd.lpSurface==NULL){status(700);dxerror();}
        if(i==0&&j==0&&k==0)status(1207);
//        dxstexture[TEXSPACEOFF+j*TEXX+begr(i+1, TEXX)]->GetDC(&dxtexturedc2);
        dxsd2.dwSize=sizeof(DDSURFACEDESC2);
        if(i==0&&j==0&&k==0)status(1208);
        dxstexture[TEXSPACEOFF+j*TEXX+begr(i+1, TEXX)]->GetSurfaceDesc( &dxsd2 );
        if(i==0&&j==0&&k==0)status(1209);
        dxstexture[TEXSPACEOFF+j*TEXX+begr(i+1, TEXX)]->Lock( NULL, &dxsd2, DDLOCK_WAIT, 0 );
        if(i==0&&j==0&&k==0)status(1210);
        unsigned int *texbuf2=(unsigned int*)dxsd2.lpSurface;
        unsigned short *texbuf2w=(unsigned short*)dxsd2.lpSurface;
        if(i==0&&j==0&&k==0)status(1211);
        if(dxsd2.lpSurface==NULL){status(700);dxerror();}
        if(i==0&&j==0&&k==0)status(1212);
//        color=GetPixel(dxtexturedc2, 0, k);
        if(dsize==16){
          if(i==0&&j==0&&k==0)status(1213);
          colorw=texbuf2w[k*TXRES+0];
          if(i==0&&j==0&&k==0)status(1214);
          texbufw[k*TXRES+TXRES-1]=colorw;
          if(i==0&&j==0&&k==0)status(1215);
        } else {
          if(i==0&&j==0&&k==0)status(1216);
          color=texbuf2[k*TXRES+0];
          if(i==0&&j==0&&k==0)status(1217);
          texbuf[k*TXRES+TXRES-1]=color;
          if(i==0&&j==0&&k==0)status(1218);
        }
        if(i==0&&j==0&&k==0)status(1219);
//        dxstexture[TEXSPACEOFF+j*TEXX+begr(i+1, TEXX)]->ReleaseDC(dxtexturedc2);
        dxstexture[TEXSPACEOFF+j*TEXX+begr(i+1, TEXX)]->Unlock(0);
        if(i==0&&j==0&&k==0)status(1220);
//        dxstexture[TEXSPACEOFF+begr(j+1,TEXY)*TEXX+i]->GetDC(&dxtexturedc2);
        dxsd2.dwSize=sizeof(DDSURFACEDESC2);
        if(i==0&&j==0&&k==0)status(1221);
        dxstexture[TEXSPACEOFF+begr(j+1,TEXY)*TEXX+i]->GetSurfaceDesc( &dxsd2 );
        if(i==0&&j==0&&k==0)status(1222);
        dxstexture[TEXSPACEOFF+begr(j+1,TEXY)*TEXX+i]->Lock( NULL, &dxsd2, DDLOCK_WAIT, 0 );
        if(i==0&&j==0&&k==0)status(1223);
        texbuf2=(unsigned int*)dxsd2.lpSurface;
        texbuf2w=(unsigned short*)dxsd2.lpSurface;
        if(i==0&&j==0&&k==0)status(1224);
        if(dxsd2.lpSurface==NULL){status(700);dxerror();}
        if(i==0&&j==0&&k==0)status(1225);
//        color=GetPixel(dxtexturedc2, k, 0);
        if(dsize==16){
          if(i==0&&j==0&&k==0)status(1226);
          colorw=texbuf2w[k];
          if(i==0&&j==0&&k==0)status(1227);
          texbufw[TXRES*(TYRES-1)+k]=colorw;
          if(i==0&&j==0&&k==0)status(1228);
        } else {
          if(i==0&&j==0&&k==0)status(1229);
          color=texbuf2[k];
          if(i==0&&j==0&&k==0)status(1230);
          texbuf[TXRES*(TYRES-1)+k]=color;
          if(i==0&&j==0&&k==0)status(1231);
        }
        if(i==0&&j==0&&k==0)status(1232);
//        dxstexture[TEXSPACEOFF+begr(j+1, TEXY)*8+i]->ReleaseDC(dxtexturedc2);
        dxstexture[TEXSPACEOFF+begr(j+1, TEXY)*8+i]->Unlock(0);
        if(i==0&&j==0&&k==0)status(1233);
//        dxstexture[TEXSPACEOFF+j*TEXX+i]->ReleaseDC(dxtexturedc);
        dxstexture[TEXSPACEOFF+j*TEXX+i]->Unlock(0);
        if(i==0&&j==0&&k==0)status(1234);
      }
      if(i==0&&j==0)status(1235);
    }
    if(i==0)status(1236);
  }
  status(1237);
}

void initterratex(void){
  status(500);
  ZeroMemory(&dxsd, sizeof(dxsd));
  dxsd.dwSize = sizeof(dxsd);
  dxsd.dwFlags = DDSD_CAPS | DDSD_WIDTH | DDSD_HEIGHT | DDSD_PIXELFORMAT;
  dxsd.dwWidth = TXRES;
  dxsd.dwHeight = TYRES;
  DDPIXELFORMAT dxtexpf;
  dxttexr=0;
  dxttexg=0;
  dxttexb=0;
  dxd3ddevice->EnumTextureFormats( TerraTextureSearchCallback, (VOID*)&dxtexpf );
  memcpy( &dxsd.ddpfPixelFormat, &dxtexpf, sizeof(DDPIXELFORMAT) );
  dxttexredr=dxttexr;
  dxttexred1=1;
  if(dxttexr>0){
    while((dxttexredr&1)==0){
      dxttexredr=dxttexredr>>1;
      dxttexred1=dxttexred1<<1;
    }
  }
  dxttexgreenr=dxttexg;
  dxttexgreen1=1;
  if(dxttexg>0){
    while((dxttexgreenr&1)==0){
      dxttexgreenr=dxttexgreenr>>1;
      dxttexgreen1=dxttexgreen1<<1;
    }
  }
//  status(dxttexgreenr);dxerror();
  dxttexbluer=dxttexb;
  dxttexblue1=1;
  if(dxttexb>0){
    while((dxttexbluer&1)==0){
      dxttexbluer=dxttexbluer>>1;
      dxttexblue1=dxttexblue1<<1;
    }
  }
  for(int i=0;i<TEXX;i++){
    for(int j=0;j<TEXY;j++){
      status(501);
      dxsd.ddsCaps.dwCaps = DDSCAPS_TEXTURE | DDSCAPS_VIDEOMEMORY;
      if(dxdd->CreateSurface(&dxsd, &dxstexture[TEXSPACEOFF+j*TEXX+i], NULL)!=D3D_OK){
        dxsd.ddsCaps.dwCaps = DDSCAPS_TEXTURE | DDSCAPS_SYSTEMMEMORY;
        if(dxdd->CreateSurface(&dxsd, &dxstexture[TEXSPACEOFF+j*TEXX+i], NULL)!=D3D_OK) dxerror();
      }
      status(502);
    }
  }
  status(507);
  initgreen();
}

HRESULT CALLBACK TextureSearchCallback( DDPIXELFORMAT* pddpf, VOID* param )
{
    if( pddpf->dwRGBAlphaBitMask>=dxtexalpha&&pddpf->dwRGBAlphaBitMask<=0xFF000000
      &&pddpf->dwRBitMask>0
      &&pddpf->dwGBitMask>0
      &&pddpf->dwBBitMask>0){
      if(pddpf->dwRGBAlphaBitMask>dxtexalpha){
        memcpy( param, pddpf, sizeof(DDPIXELFORMAT) );
        dxtexr=pddpf->dwRBitMask;
        dxtexg=pddpf->dwGBitMask;
        dxtexb=pddpf->dwBBitMask;
        dxtexalpha=pddpf->dwRGBAlphaBitMask;
        return DDENUMRET_OK;
      }
      if(pddpf->dwRBitMask>=dxtexr&&pddpf->dwRBitMask<=0xFF0000
        &&pddpf->dwGBitMask>=dxtexg&&pddpf->dwGBitMask<=0xFF00
        &&pddpf->dwBBitMask>=dxtexb&&pddpf->dwBBitMask<=0xFF) {
          memcpy( param, pddpf, sizeof(DDPIXELFORMAT) );
          dxtexr=pddpf->dwRBitMask;
          dxtexg=pddpf->dwGBitMask;
          dxtexb=pddpf->dwBBitMask;
          dxtexalpha=pddpf->dwRGBAlphaBitMask;
          return DDENUMRET_OK;
      }
    }
    return DDENUMRET_OK;
}

void loadtex(int to, char* fname, int width, int height, bool alphamap){
  status(600);
  ZeroMemory(&dxsd, sizeof(dxsd));
  dxsd.dwSize = sizeof(dxsd);
  dxsd.dwFlags = DDSD_CAPS | DDSD_WIDTH | DDSD_HEIGHT | DDSD_PIXELFORMAT/* | DDSD_CKSRCBLT*/;
/*  DDCOLORKEY ckey;
  ckey.dwColorSpaceLowValue=0x00000000;
  ckey.dwColorSpaceHighValue=0x00000000;
  dxsd.ddckCKSrcBlt = ckey;*/
  dxsd.dwWidth = width;
  dxsd.dwHeight = height;
  dxsd.ddsCaps.dwCaps = DDSCAPS_TEXTURE | DDSCAPS_VIDEOMEMORY;
  DDPIXELFORMAT dxtexpf;
  dxtexr=0;
  dxtexg=0;
  dxtexb=0;
  dxtexalpha=0;
  dxd3ddevice->EnumTextureFormats( TextureSearchCallback, (VOID*)&dxtexpf );
  memcpy( &dxsd.ddpfPixelFormat, &dxtexpf, sizeof(DDPIXELFORMAT) );
  FILE *bm;
  unsigned char *buf;
  buf=(unsigned char*)VirtualAlloc(NULL, width*height*3, MEM_RESERVE|MEM_COMMIT, PAGE_READWRITE);
  bm=fopen(fname, "rb");
  fseek(bm, -width*height*3, SEEK_END);
  fread(buf, 1, width*height*3, bm);
  fclose(bm);
  status(601);
  dxsd.ddsCaps.dwCaps = DDSCAPS_TEXTURE | DDSCAPS_VIDEOMEMORY;// | DDSCAPS_MIPMAP | DDSCAPS_COMPLEX;
  if(dxdd->CreateSurface(&dxsd, &dxstexture[to], NULL)!=D3D_OK){
    status(602);
    dxsd.ddsCaps.dwCaps = DDSCAPS_TEXTURE | DDSCAPS_SYSTEMMEMORY;// | DDSCAPS_MIPMAP | DDSCAPS_COMPLEX;
    if(dxdd->CreateSurface(&dxsd, &dxstexture[to], NULL)!=D3D_OK){status(620);dxerror();}
    status(603);
  }
  status(604);
  dxsd.dwSize=sizeof(DDSURFACEDESC2);
  status(605);
  dxstexture[to]->GetSurfaceDesc( &dxsd );
  status(606);
  dxstexture[to]->Lock( NULL, &dxsd, DDLOCK_WAIT, 0 );
  status(607);
  int dsize=dxsd.ddpfPixelFormat.dwRGBBitCount;
  unsigned int *texbuf=(unsigned int*)dxsd.lpSurface;
  unsigned short *texbufw=(unsigned short*)dxsd.lpSurface;
  status(608);
  if(dxsd.lpSurface==NULL){status(700);dxerror();}
  status(609);
  unsigned int alphar=dxtexalpha;
  unsigned int alpha1=1;
  if(dxtexalpha>0){
    while((alphar&1)==0){
      alphar=alphar>>1;
      alpha1=alpha1<<1;
    }
  }
  unsigned int redr=dxtexr;
  unsigned int red1=1;
  if(dxtexr>0){
    while((redr&1)==0){
      redr=redr>>1;
      red1=red1<<1;
    }
  }
  unsigned int greenr=dxtexg;
  unsigned int green1=1;
  if(dxtexg>0){
    while((greenr&1)==0){
      greenr=greenr>>1;
      green1=green1<<1;
    }
  }
  unsigned int bluer=dxtexb;
  unsigned int blue1=1;
  if(dxtexb>0){
    while((bluer&1)==0){
      bluer=bluer>>1;
      blue1=blue1<<1;
    }
  }
  for(int i=0;i<height;i++){
    for(int j=0;j<width;j++){
      int alpha=buf[(i*width+j)*3]+buf[(i*width+j)*3+1]+buf[(i*width+j)*3+2];
/*      if(fname=="rauch.bmp"){
        if(alpha>255)alpha=255;
        texbuf[((height-1)-i)*width+j]=16777216*alpha+0xFFFFFF;
      } else {*/
        if(dxtexalpha>0){
          if(alpha<128){
            alpha=2*alpha;
          }else{
            alpha=255;
          }
        } else {
          alpha=0;
        }
//        texbuf[((height-1)-i)*width+j]=16777216*alpha+65536*buf[(i*width+j)*3+2]+256*buf[(i*width+j)*3+1]+buf[(i*width+j)*3];
        if(dsize==16){
          texbufw[((height-1)-i)*width+j]=alpha1*(unsigned int)((float)alpha*alphar/255.0)
                                         +red1*(unsigned int)((float)buf[(i*width+j)*3+2]*(float)redr/255.0)
                                         +green1*(unsigned int)((float)buf[(i*width+j)*3+1]*(float)greenr/255.0)
                                         +blue1*(unsigned int)((float)buf[(i*width+j)*3]*(float)bluer/255.0);
        } else{
          texbuf[((height-1)-i)*width+j]=alpha1*(unsigned int)((float)alpha*alphar/255.0)
                                        +red1*(unsigned int)((float)buf[(i*width+j)*3+2]*(float)redr/255.0)
                                        +green1*(unsigned int)((float)buf[(i*width+j)*3+1]*(float)greenr/255.0)
                                        +blue1*(unsigned int)((float)buf[(i*width+j)*3]*(float)bluer/255.0);
        }
//      }
    }
  }    
  status(610);
  dxstexture[to]->Unlock(0);
  status(611);
/*  dxstexture[to]->GetDC(&dxtexturedc);
  for(int i=0;i<height;i++){
    for(int j=0;j<width;j++){
      int alpha=buf[(i*width+j)*3]+buf[(i*width+j)*3+1]+buf[(i*width+j)*3+2];
      SetPixel(dxtexturedc, i, j, 16777216*0xFF+65536*buf[(i*width+j)*3]+256*buf[(i*width+j)*3+1]+buf[(i*width+j)*3+2]);
    }
  }    
  status(612);
  dxstexture[to]->ReleaseDC(dxtexturedc);*/
  status(613);
  VirtualFree(buf, width*height*3, MEM_DECOMMIT|MEM_RELEASE);
  status(614);
//  if(dxstexture2->QueryInterface(IID_IDirect3DTexture2, (LPVOID *)&dxtexture) != S_OK) dxerror();
//  dxtexture->GetHandle(dxd3ddevice, (DWORD*)&dxhtexture[to]);
//  dxtexture->Release();
}

void loadmenu(int n){
  status(1600);
  dxstexture[TEXTSPACEOFF]->GetDC(&dxtexturedc);
  status(1601);
  for(int i=0;i<256;i++){
    for(int j=0;j<256;j++){
      if(i==0||i==255||j==0||j==255){
        SetPixel(dxtexturedc, i, j, 0x000000);
      } else{
        SetPixel(dxtexturedc, i, j, 0xFFFFFF);
      }
    }
  }
  status(1602);
  DeleteObject(SelectObject(dxtexturedc, CreatePen(PS_SOLID, 1, 0xFFFFFF)));
  DeleteObject(SelectObject(dxtexturedc, CreateSolidBrush(0xFFFFFF)));
  DeleteObject(SelectObject(dxtexturedc, CreateFont(18,10,0,0,400,false,false,false,ANSI_CHARSET,OUT_STROKE_PRECIS,CLIP_STROKE_PRECIS,PROOF_QUALITY,DEFAULT_PITCH||FF_ROMAN,"Courier New")));
  SetBkColor(dxtexturedc, 0xFFFFFF);
  status(1603);
  if(n==0){
    TextOut(dxtexturedc, 10, 10, mission.name, mission.namelen);
    for(int i=0;i<ORDERLINES;i++)if(mission.orders[i]!=NULL)TextOut(dxtexturedc, 10, 40+i*20, mission.orders[i], mission.orderlen[i]);
    DeleteObject(SelectObject(dxtexturedc, CreateFont(15,8,0,0,400,false,false,false,ANSI_CHARSET,OUT_STROKE_PRECIS,CLIP_STROKE_PRECIS,PROOF_QUALITY,DEFAULT_PITCH||FF_ROMAN,"Courier New")));
    TextOut(dxtexturedc, 10, 215, "press 'O' to toggle orders", 26);
  }
  if(n==1){
    TextOut(dxtexturedc, 10, 10, "Main Menu", 9);
    TextOut(dxtexturedc, 10, 50, "Orders", 6);
    TextOut(dxtexturedc, 10, 70, "New Mission", 11);
    TextOut(dxtexturedc, 10, 90, "Credits", 7);
    TextOut(dxtexturedc, 10, 110, "Quit", 4);
//    TextOut(dxtexturedc, 10, 70, "Start new Mission", 17);
  }
  if(n==4){
    TextOut(dxtexturedc, 10, 10, "Credits", 7);
    DeleteObject(SelectObject(dxtexturedc, CreateFont(12,6,0,0,400,false,false,false,ANSI_CHARSET,OUT_STROKE_PRECIS,CLIP_STROKE_PRECIS,PROOF_QUALITY,DEFAULT_PITCH||FF_SWISS,"Courier New")));
    TextOut(dxtexturedc, 10, 30, "Project management:", 19);
    TextOut(dxtexturedc, 10, 40, "Christian Reimann", 17);
    TextOut(dxtexturedc, 10, 50, "Programming:", 12);
    TextOut(dxtexturedc, 10, 60, "Christian Reimann", 17);
    TextOut(dxtexturedc, 10, 70, "Beta testing:", 13);
    TextOut(dxtexturedc, 10, 80, "Susanne Sass", 12);
    TextOut(dxtexturedc, 10, 90, "Daniel Nielsen", 14);
    TextOut(dxtexturedc, 10, 100, "Gerhard ""skyreacher"" Dietrichsteiner", 34);
    TextOut(dxtexturedc, 10, 110, "3D Model designer:", 18);
    TextOut(dxtexturedc, 10, 120, "Christian Reimann", 17);
    TextOut(dxtexturedc, 10, 130, "Code optimizing:", 16);
    TextOut(dxtexturedc, 10, 140, "Christian Reimann", 17);
    TextOut(dxtexturedc, 10, 150, "Daniel Nielsen", 14);
    TextOut(dxtexturedc, 10, 160, "Mission designer:", 17);
    TextOut(dxtexturedc, 10, 170, "Christian Reimann", 17);
    TextOut(dxtexturedc, 10, 180, "Sound effects:", 14);
    TextOut(dxtexturedc, 10, 190, "Christian Reimann", 17);
    TextOut(dxtexturedc, 10, 210, "Find updates, new versions and", 30);
    TextOut(dxtexturedc, 10, 220, "support on www.infinitecode.com", 31);
    DeleteObject(SelectObject(dxtexturedc, CreateFont(18,10,0,0,400,false,false,false,ANSI_CHARSET,OUT_STROKE_PRECIS,CLIP_STROKE_PRECIS,PROOF_QUALITY,DEFAULT_PITCH||FF_ROMAN,"Courier New")));
//    TextOut(dxtexturedc, 10, 70, "Start new Mission", 17);
  }
  if(n==2){
    if( mission.success)TextOut(dxtexturedc, 20, 100, "Mission accomplished", 20);
    if(!mission.success)TextOut(dxtexturedc, 50, 100, "Mission failed", 14);
  }
  if(n==3){
    for(int i=0;i<DISPLAYEDMISSIONS;i++){
/*      if(view.mfnames[i]!=NULL)free(view.mfnames[i]);
      view.mfnames[i]=(char*)malloc(80);*/
      strcpy(view.mfnames[i], "");
    }
    TextOut(dxtexturedc, 10, 10, "New Mission", 11);
    WIN32_FIND_DATA data;
    int num=0;
    HANDLE h=FindFirstFile("*.mis", &data);
    if(view.menuscroll==0){
      TextOut(dxtexturedc, 10, 50, data.cFileName, strlen(data.cFileName));
      strcpy(view.mfnames[0], data.cFileName);
    }
    while(FindNextFile(h, &data)){
      num++;
      if(num-view.menuscroll>=0&&num-view.menuscroll<DISPLAYEDMISSIONS){
        TextOut(dxtexturedc, 10, 50+20*(num-view.menuscroll), data.cFileName, strlen(data.cFileName));
//        strcpy(view.mfnames[num-view.menuscroll], data.cFileName);
/*        for(int i=0;i<strlen(data.cFileName);i++){
          view.mfnames[num-view.menuscroll][i]=data.cFileName[i];
        }
        view.mfnames[num-view.menuscroll][strlen(data.cFileName)]=0;*/
//        memcpy(&view.mfnames[num-view.menuscroll][0], &data.cFileName[0], strlen(data.cFileName)+1);
        strcpy(view.mfnames[num-view.menuscroll], data.cFileName);
      }
    }
    view.menumaxscroll=num-(DISPLAYEDMISSIONS-1);
    FindClose(h);
  }
  status(1604);
  TextOut(dxtexturedc, 10, 235, "press ESC to toggle menu", 24);
  status(1605);
  dxstexture[TEXTSPACEOFF]->ReleaseDC(dxtexturedc);
  status(1606);
  dxsd.dwSize=sizeof(DDSURFACEDESC2);
  status(1607);
  dxstexture[TEXTSPACEOFF]->GetSurfaceDesc( &dxsd );
  status(1608);
  dxstexture[TEXTSPACEOFF]->Lock( NULL, &dxsd, DDLOCK_WAIT, 0 );
  status(1609);
  int dsize=dxsd.ddpfPixelFormat.dwRGBBitCount;
  unsigned int *texbuf=(unsigned int*)dxsd.lpSurface;
  unsigned short *texbufw=(unsigned short*)dxsd.lpSurface;
  status(1610);
  if(dxsd.lpSurface==NULL){status(700);dxerror();}
  status(1611);
  if(n==3){
    if(dsize==16){
      for(int i=0;i<10;i++){
        texbufw[(128+10+i)*256+245]=0x0000;
        texbufw[(128-10-i)*256+245]=0x0000;
      }
      for(int i=0;i<5;i++){
        texbufw[(128+20-i)*256+245-i]=0x0000;
        texbufw[(128+20-i)*256+245+i]=0x0000;
        texbufw[(128-20+i)*256+245-i]=0x0000;
        texbufw[(128-20+i)*256+245+i]=0x0000;
      }
    } else{
      for(int i=0;i<10;i++){
        texbuf[(128+10+i)*256+245]=0x00000000;
        texbuf[(128-10-i)*256+245]=0x00000000;
      }
      for(int i=0;i<5;i++){
        texbuf[(128+20-i)*256+245-i]=0x00000000;
        texbuf[(128+20-i)*256+245+i]=0x00000000;
        texbuf[(128-20+i)*256+245-i]=0x00000000;
        texbuf[(128-20+i)*256+245+i]=0x00000000;
      }
    }
  }
  status(1612);
  for(int i=0;i<256;i++){
    for(int j=0;j<256;j++){
//      SetPixel(dxtexturedc, i, j, (GetPixel(dxtexturedc, i, j)^0xFFFFFF)+0x1000000*i);
      unsigned int talpha=dxxtexalpha1*(unsigned int)((float)TEXTOPACITY/255.0*(float)dxxtexalphar);
      if(talpha==0)talpha=dxxtexalpha1;
      if(dsize==16){
        texbufw[j*256+i]=((((unsigned int)(texbufw[j*256+i]))&(dxxtexred1*dxxtexredr+dxxtexgreen1*dxxtexgreenr+dxxtexblue1*dxxtexbluer))
                          ^(dxxtexred1*dxxtexredr+dxxtexgreen1*dxxtexgreenr+dxxtexblue1*dxxtexbluer))
                         +talpha;
      } else{
        texbuf[j*256+i]=((((unsigned int)(texbuf[j*256+i]))&(dxxtexred1*dxxtexredr+dxxtexgreen1*dxxtexgreenr+dxxtexblue1*dxxtexbluer))
                         ^(dxxtexred1*dxxtexredr+dxxtexgreen1*dxxtexgreenr+dxxtexblue1*dxxtexbluer))
                        +talpha;
      }
    }
  }
  status(1613);
  dxstexture[TEXTSPACEOFF]->Unlock(0);
  status(1614);
}

void inittexttex(void){
  status(1500);
  dxsd.dwFlags = DDSD_CAPS | DDSD_WIDTH | DDSD_HEIGHT | DDSD_PIXELFORMAT;
  dxsd.dwWidth = 256;
  dxsd.dwHeight = 256;
  DDPIXELFORMAT dxtexpf;
  dxtexr=0;
  dxtexg=0;
  dxtexb=0;
  dxtexalpha=0;
  status(1501);
  dxd3ddevice->EnumTextureFormats( TextureSearchCallback, (VOID*)&dxtexpf );
  status(1502);
  memcpy( &dxsd.ddpfPixelFormat, &dxtexpf, sizeof(DDPIXELFORMAT) );
  status(1503);
  dxxtexalphar=dxtexalpha;
  dxxtexalpha1=1;
  status(1504);
  if(dxtexalpha>0){
    while((dxxtexalphar&1)==0){
      dxxtexalphar=dxxtexalphar>>1;
      dxxtexalpha1=dxxtexalpha1<<1;
    }
  }
  dxxtexredr=dxtexr;
  dxxtexred1=1;
  if(dxtexr>0){
    while((dxxtexredr&1)==0){
      dxxtexredr=dxxtexredr>>1;
      dxxtexred1=dxxtexred1<<1;
    }
  }
  dxxtexgreenr=dxtexg;
  dxxtexgreen1=1;
  if(dxtexg>0){
    while((dxxtexgreenr&1)==0){
      dxxtexgreenr=dxxtexgreenr>>1;
      dxxtexgreen1=dxxtexgreen1<<1;
    }
  }
  dxxtexbluer=dxtexb;
  dxxtexblue1=1;
  if(dxtexb>0){
    while((dxxtexbluer&1)==0){
      dxxtexbluer=dxxtexbluer>>1;
      dxxtexblue1=dxxtexblue1<<1;
    }
  }
  status(1505);
  dxsd.ddsCaps.dwCaps = DDSCAPS_TEXTURE | DDSCAPS_VIDEOMEMORY;
  status(1506);
  if(dxdd->CreateSurface(&dxsd, &dxstexture[TEXTSPACEOFF], NULL)!=D3D_OK){
    status(1507);
    dxsd.ddsCaps.dwCaps = DDSCAPS_TEXTURE | DDSCAPS_SYSTEMMEMORY;
    status(1508);
    dxdd->CreateSurface(&dxsd, &dxstexture[TEXTSPACEOFF], NULL);  
    status(1509);
  }
  status(1510);
  loadmenu(0);
  status(1511);
}

void dxinittex(void){
  status(400);
  ZeroMemory(&dxsd, sizeof(dxsd));
  dxsd.dwSize = sizeof(dxsd);
  dxsd.dwFlags = DDSD_CAPS | DDSD_WIDTH | DDSD_HEIGHT;
  // tex.tarnfleck
/*  dxsd.dwWidth = 64;
  dxsd.dwHeight = 64;
  dxsd.ddsCaps.dwCaps = DDSCAPS_TEXTURE | DDSCAPS_VIDEOMEMORY;
  status(401);
  if(dxdd->CreateSurface(&dxsd, &dxstexture[0], NULL)!=D3D_OK){
    dxsd.ddsCaps.dwCaps = DDSCAPS_TEXTURE | DDSCAPS_SYSTEMMEMORY;
    dxdd->CreateSurface(&dxsd, &dxstexture[0], NULL);  
  }
  status(402);
  dxstexture[0]->GetDC(&dxtexturedc);
  status(403);
  for(int i=0;i<64;i++){
    for(int j=0;j<64;j++){
      SetPixel(dxtexturedc, i, j, (65536+256+1)*(long)(255*(sin(i/8.0)*sin(j/5.0)*0.25+0.75)*(sin(j/8.0)*cos(i/15.0)*0.25+0.75)));
    }
  }    
  status(404);
  dxstexture[0]->ReleaseDC(dxtexturedc);
  status(405);*/
  // tex.tarnfleck2
/*  dxsd.dwWidth = 64;
  dxsd.dwHeight = 64;
  dxsd.ddsCaps.dwCaps = DDSCAPS_TEXTURE | DDSCAPS_VIDEOMEMORY;
  if(dxdd->CreateSurface(&dxsd, &dxstexture[5], NULL)!=D3D_OK){
    dxsd.ddsCaps.dwCaps = DDSCAPS_TEXTURE | DDSCAPS_SYSTEMMEMORY;
    dxdd->CreateSurface(&dxsd, &dxstexture[5], NULL);  
  }
  dxstexture[5]->GetDC(&dxtexturedc);
  for(int i=0;i<64;i++){
    for(int j=0;j<64;j++){
      SetPixel(dxtexturedc, i, j, (0*65536+256+0*1)*(long)(255*(sin(i/8.0)*sin(j/5.0)*0.25+0.75)*(sin(j/8.0)*cos(i/15.0)*0.25+0.75)));
    }
  }    
  dxstexture[5]->ReleaseDC(dxtexturedc);
//  if(dxstexture2->QueryInterface(IID_IDirect3DTexture2, (LPVOID *)&dxtexture) != S_OK) dxerror();
//  dxtexture->GetHandle(dxd3ddevice, (DWORD*)&dxhtexture[0]);
//  dxtexture->Release();
  status(406);*/
  // tex.ketten
  dxsd.dwWidth = 32;
  dxsd.dwHeight = 32;
  dxsd.ddsCaps.dwCaps = DDSCAPS_TEXTURE | DDSCAPS_VIDEOMEMORY;// | DDSCAPS_MIPMAP | DDSCAPS_COMPLEX;
  if(dxdd->CreateSurface(&dxsd, &dxstexture[1], NULL)!=D3D_OK){
    dxsd.ddsCaps.dwCaps = DDSCAPS_TEXTURE | DDSCAPS_SYSTEMMEMORY;// | DDSCAPS_MIPMAP | DDSCAPS_COMPLEX;
    dxdd->CreateSurface(&dxsd, &dxstexture[1], NULL);  
  }
  dxstexture[1]->GetDC(&dxtexturedc);
  for(int i=0;i<32;i++){
    for(int j=0;j<32;j++){
      if(i>6&&i<32-6){
        SetPixel(dxtexturedc, i, j, (65536+256+1)*(long)(64*((j/4)%2)));
      } else {
        SetPixel(dxtexturedc, i, j, (65536+256+1)*(long)(64*(((j/4)+1)%2)));
      }
    }
  }    
  dxstexture[1]->ReleaseDC(dxtexturedc);
//  if(dxstexture2->QueryInterface(IID_IDirect3DTexture2, (LPVOID *)&dxtexture) != S_OK) dxerror();
//  dxtexture->GetHandle(dxd3ddevice, (DWORD*)&dxhtexture[1]);
//  dxtexture->Release();
  status(407);
  // tex.hgras
  dxsd.dwWidth = 8;
  dxsd.dwHeight = 8;
  dxsd.ddsCaps.dwCaps = DDSCAPS_TEXTURE | DDSCAPS_VIDEOMEMORY;
  if(dxdd->CreateSurface(&dxsd, &dxstexture[2], NULL)!=D3D_OK){
    dxsd.ddsCaps.dwCaps = DDSCAPS_TEXTURE | DDSCAPS_SYSTEMMEMORY;
    dxdd->CreateSurface(&dxsd, &dxstexture[2], NULL);  
  }
  dxstexture[2]->GetDC(&dxtexturedc);
  for(int i=0;i<8;i++){
    for(int j=0;j<8;j++){
      SetPixel(dxtexturedc, i, j, (256)*(128+rand()%128));
    }
  }    
  dxstexture[2]->ReleaseDC(dxtexturedc);
//  if(dxstexture2->QueryInterface(IID_IDirect3DTexture2, (LPVOID *)&dxtexture) != S_OK) dxerror();
//  dxtexture->GetHandle(dxd3ddevice, (DWORD*)&dxhtexture[2]);
//  dxtexture->Release();
  // tex.explosion
  loadtex(0, "cam1.bmp", 64, 64, false);
  status(408);
  loadtex(3, "expl.bmp", 64, 64, false);
  // tex.rauch
  loadtex(4, "rauch.bmp", 64, 64, false);
  loadtex(5, "cam2.bmp", 64, 64, false);
  loadtex(6, "art.bmp", 64, 64, false);
  loadtex(7, "windows1.bmp", 64, 64, false);
  loadtex(9, "windows2.bmp", 64, 64, false);
  loadtex(10, "dead.bmp", 64, 64, true);
  loadtex(11, "wolf.bmp", 128, 128, false);
  loadtex(12, "wolf2.bmp", 128, 128, false);
  status(409);
  // tex.tree
  loadtex(TREESPACEOFF, "tree.bmp", 64, 64, true);
  // tex.bush
  loadtex(TREESPACEOFF+1, "bush.bmp", 64, 64, true);
  loadtex(TREESPACEOFF+2, "tree2.bmp", 64, 64, true);
  loadtex(TREESPACEOFF+3, "tree3.bmp", 64, 64, true);
  status(410);
  // tex.terra
  initterratex();
  // tex.text zuletzt damit, wenn Videospeicher knapp ist, in Systemspeicher
  status(411);
}

void setmatopacity(float diffa, float diff, float amb, float spec){
  // mat.objects
  RELEASE(dxd3dmat);
//  dxd3d->CreateMaterial(&dxd3dmat, NULL);
  memset(&dxmat, 0, sizeof(D3DMATERIAL7));
  dxmat.diffuse.r = diff;
  dxmat.diffuse.g = diff;
  dxmat.diffuse.b = diff;
  dxmat.diffuse.a = diffa;
  dxmat.ambient.r = amb;
  dxmat.ambient.g = amb;
  dxmat.ambient.b = amb;
  dxmat.ambient.a = diffa;
  dxmat.specular.r = spec;// Licht spiegeln
  dxmat.specular.g = spec;
  dxmat.specular.b = spec;
  dxmat.specular.a = spec;
  dxmat.power = (float)0.5;
  dxd3ddevice->SetMaterial(&dxmat);
//  dxd3dmat->SetMaterial(&dxmat);
//  dxd3dmat->GetHandle(dxd3ddevice, &dxhmat);
//  dxd3ddevice->SetLightState(D3DLIGHTSTATE_MATERIAL,dxhmat);
}

void dxinitlight(){
  // material
//  dxd3d->CreateMaterial(&dxd3dmat, NULL);
  memset(&dxmat, 0, sizeof(D3DMATERIAL7));
  dxmat.diffuse.r = 1.0;
  dxmat.diffuse.g = (D3DVALUE)1.0;
  dxmat.diffuse.b = (D3DVALUE)1.0;
  dxmat.diffuse.a = (D3DVALUE)1.0;
  dxmat.ambient.r = 1.0;
  dxmat.ambient.g = (D3DVALUE)1.0;
  dxmat.ambient.b = (D3DVALUE)1.0;
  dxmat.ambient.a = (D3DVALUE)1.0;
  dxmat.specular.r = (D3DVALUE)0.5;// Licht spiegeln
  dxmat.specular.g = (D3DVALUE)0.5;
  dxmat.specular.b = (D3DVALUE)0.5;
  // mat.background
  dxd3ddevice->SetMaterial(&dxmat);
//  dxd3dmat->GetHandle(dxd3ddevice, &dxhmat);
//  dxd3dviewport->SetBackground(dxhmat);
  // mat.objects
  setmatopacity(1, 1, 1, 0.3);
  // lighting
//  dxd3d->CreateLight(&dxd3dlight, NULL);
  memset(&dxlight, 0, sizeof(D3DLIGHT7));
  dxlight.dltType = D3DLIGHT_DIRECTIONAL;
  dxlight.dcvDiffuse.r = 0*0+mission.light[0].r;
  dxlight.dcvDiffuse.g = 0.0*0+mission.light[0].g;
  dxlight.dcvDiffuse.b = D3DVAL(0.8)*0+mission.light[0].b;
  dxlight.dvAttenuation0 = 0.0;
  dxlight.dvAttenuation1 = 0.0;
  dxlight.dvAttenuation2 = 0.0;
  dxlight.dvPosition.x = 0.0*0+mission.light[0].x;
  dxlight.dvPosition.y = D3DVAL(0.0)*0+mission.light[0].y;
  dxlight.dvPosition.z = D3DVAL(0)*0+mission.light[0].z;
  dxlight.dvDirection.x = 0;
  dxlight.dvDirection.y = D3DVAL(0.0);
  dxlight.dvDirection.z = D3DVAL(1);
  dxd3ddevice->SetLight(1, &dxlight);
  dxd3ddevice->LightEnable(1, TRUE);
//  dxd3dviewport->AddLight(dxd3dlight);
//  dxd3d->CreateLight(&dxd3dlight, NULL);
  dxlight.dcvDiffuse.r = 0.8*0+mission.light[1].r;
  dxlight.dcvDiffuse.g = 0.7*0+mission.light[1].g;
  dxlight.dcvDiffuse.b = D3DVAL(0.2)*0+mission.light[1].b;
  dxlight.dvDirection.x = 1*0+mission.light[1].x;
  dxlight.dvDirection.y = D3DVAL(0.0)*0+mission.light[1].y;
  dxlight.dvDirection.z = D3DVAL(0.5)*0+mission.light[1].z;
  dxd3ddevice->SetLight(2, &dxlight);
  dxd3ddevice->LightEnable(2, TRUE);
//  dxd3dviewport->AddLight(dxd3dlight);
}

static HRESULT WINAPI EnumZBufferCallback( DDPIXELFORMAT* pddpf,
                                           VOID* pddpfDesired )
{
    if( pddpf->dwFlags == DDPF_ZBUFFER )
    {
        if(pddpf->dwZBufferBitDepth>dxzbits){
          memcpy( pddpfDesired, pddpf, sizeof(DDPIXELFORMAT) );
          dxzbits=pddpf->dwZBufferBitDepth;
        }
        // Return with D3DENUMRET_CANCEL to end the search.
		return D3DENUMRET_CANCEL;
    }

    // Return with D3DENUMRET_OK to continue the search.
    return D3DENUMRET_OK;
}

static HRESULT WINAPI 
EnumDeviceCallback(LPSTR            lpszDeviceDesc, 
                   LPSTR            lpszDeviceName, 
                   LPD3DDEVICEDESC7 lpd3dEnumDeviceDesc, 
                   LPVOID           lpUserArg) 
{ 
    BOOL fIsHardware = FALSE;
    fIsHardware = (lpd3dEnumDeviceDesc->dwDevCaps & D3DDEVCAPS_HWRASTERIZATION); 
    // Does the device render at the depth we want? 
    if ((lpd3dEnumDeviceDesc->dwDeviceRenderBitDepth& DDBD_16) != DDBD_16)return D3DENUMRET_OK; 
    if ((lpd3dEnumDeviceDesc->dwDeviceZBufferBitDepth) == 0)return D3DENUMRET_OK;
    if (!(lpd3dEnumDeviceDesc->dpcTriCaps.dwShadeCaps&D3DPSHADECAPS_COLORGOURAUDRGB))return D3DENUMRET_OK; 
    if (!(lpd3dEnumDeviceDesc->dpcTriCaps.dwShadeCaps&D3DPSHADECAPS_ALPHAFLATBLEND))return D3DENUMRET_OK; 
    if (!(lpd3dEnumDeviceDesc->dwVertexProcessingCaps&D3DPTEXTURECAPS_ALPHA))return D3DENUMRET_OK;
    if (!(lpd3dEnumDeviceDesc->dpcTriCaps.dwAlphaCmpCaps&D3DPCMPCAPS_GREATEREQUAL))return D3DENUMRET_OK;
    if (!(lpd3dEnumDeviceDesc->dpcTriCaps.dwSrcBlendCaps&D3DPBLENDCAPS_SRCALPHA))return D3DENUMRET_OK;
//    if (!(lpd3dEnumDeviceDesc->dpcTriCaps.dwtextureFilterCaps&D3DPTFILTERCAPS_LINEAR))return D3DENUMRET_OK;
    // This device has the necessary capabilities. Save the details. 
    if (fIsHardware){
      *(BOOL*)lpUserArg = TRUE; 
      CopyMemory(&dxhwguid, &lpd3dEnumDeviceDesc->deviceGUID, sizeof(GUID)); 
      dxhwfound=true;
/*    strcpy(g_szDeviceDesc, lpszDeviceDesc); 
    strcpy(g_szDeviceName, lpszDeviceName); 
    CopyMemory(&g_d3dDeviceDesc, lpd3dEnumDeviceDesc, 
               sizeof(D3DDEVICEDESC7));*/
    // If this is a hardware device, it has 
    // the necessary capabilities. 
      return D3DENUMRET_OK; 
    } else {
      *(BOOL*)lpUserArg = TRUE; 
      CopyMemory(&dxrgbguid, &lpd3dEnumDeviceDesc->deviceGUID, sizeof(GUID)); 
      dxrgbfound=true;
    }
    // Otherwise, keep looking. 
    return D3DENUMRET_OK; 
} 

void dxinit(void){
  status(1110);
  status(1111);
  // Init DirectX and Direct3D
  // create direct draw object on primary surface
  status(301);
  status(1112);
  DirectDrawCreateEx( NULL, (VOID**)&dxdd, IID_IDirectDraw7, NULL );
  status(1113);
/*  LPDIRECTDRAW dxdd1;
  if(DirectDrawCreate(NULL, &dxdd1, NULL )!=DD_OK)dxerror();
  status(302);
  // create a DX7 version of the interface
  if(dxdd1->QueryInterface(IID_IDirectDraw7, (LPVOID*)&dxdd)!=DD_OK)dxerror();
  // we're done with the DD1 interface
  RELEASE(dxdd1);*/
  status(303);
  status(1114);
  // set the cooperative level
  if (dxdd->SetCooperativeLevel(hwnd, DDSCL_FULLSCREEN  | DDSCL_EXCLUSIVE | DDSCL_ALLOWMODEX | DDSCL_FPUSETUP)!=DD_OK) dxerror();
  status(304);
  if(dxdd->SetDisplayMode(XRES,YRES,BITS, 0, 0)!=DD_OK) dxerror();
  status(305);
  // create the primary surface
  ZeroMemory(&dxsd, sizeof(dxsd));
  dxsd.dwSize = sizeof(dxsd);
  dxsd.dwFlags = DDSD_CAPS|DDSD_BACKBUFFERCOUNT;
  dxsd.dwBackBufferCount=1;
  dxsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE|DDSCAPS_VIDEOMEMORY  |DDSCAPS_3DDEVICE |
                             DDSCAPS_FLIP | DDSCAPS_COMPLEX;
  if (dxdd->CreateSurface(&dxsd, &dxprimary, NULL )!=DD_OK){
    dxsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE|DDSCAPS_SYSTEMMEMORY;
    if (dxdd->CreateSurface(&dxsd, &dxprimary, NULL )!=DD_OK) dxerror();
  }
  status(306);
  DDSCAPS2 ddscaps = { DDSCAPS_BACKBUFFER, 0, 0, 0 };
  if( dxprimary->GetAttachedSurface( &ddscaps,&dxbackbuffer )!=DD_OK )dxerror();
  // Create backbuffer
/*  ZeroMemory(&dxsd, sizeof(dxsd));
  dxsd.dwSize = sizeof(dxsd);
  dxsd.dwFlags = DDSD_CAPS | DDSD_WIDTH | DDSD_HEIGHT;
  dxsd.dwWidth = XRES;
  dxsd.dwHeight = YRES;
  dxsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN | DDSCAPS_3DDEVICE | DDSCAPS_VIDEOMEMORY;
  status(307);
  if (dxdd->CreateSurface(&dxsd, &dxbackbuffer, NULL) != DD_OK){
    status(308);
    dxsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN | DDSCAPS_3DDEVICE | DDSCAPS_SYSTEMMEMORY;
    if (dxdd->CreateSurface(&dxsd, &dxbackbuffer, NULL) != DD_OK) dxerror();
    status(309);
  }
  if (dxprimary->AddAttachedSurface(dxbackbuffer) != DD_OK) dxerror();*/
  status(310);
  // get the direct3d object
  if (dxdd->QueryInterface(IID_IDirect3D7, (LPVOID*)&dxd3d)!=DD_OK) dxerror();
  status(311);
  BOOL fDeviceFound = FALSE; 
  dxhwfound=false;
  dxrgbfound=false;
  dxd3d->EnumDevices(EnumDeviceCallback, &fDeviceFound); 
  if(!fDeviceFound){
    MessageBox(hwnd, "No GUID enumerated. Trying standard GUIDs...","Hardware warning",MB_OK);
    dxhwguid=IID_IDirect3DHALDevice;
  }
  if(!dxhwfound){
    if(dxrgbfound){
      MessageBox(hwnd, "No 3d hardware enumerated. Trying enumerated RGB emulation...","Hardware warning",MB_OK);
      dxhwguid=dxrgbguid;
      fDeviceFound=true;
    } else {
      MessageBox(hwnd, "No GUID enumerated. Trying standard GUIDs...","Hardware warning",MB_OK);
      fDeviceFound=false;
    }
  }
/*D3DFINDDEVICESEARCH search;
D3DFINDDEVICERESULT result;
ZeroMemory(&search, sizeof(search));
search.dwSize = sizeof(search);
search.dwFlags = D3DFDS_HARDWARE||D3DFDS_TEXTURECAPS;
search.bHardware = true;
search.dpcPrimCaps.dwTextureCaps = D3DPTEXTURECAPS_ALPHA;
ZeroMemory(&result, sizeof(result));
result.dwSize = sizeof(result);
if (dxd3d->FindDevice(&search, &result) != D3D_OK)dxerror();
dxguid=result.guid;*/
  status(312);
  // Create a z-buffer and attach it to the backbuffer
  DDPIXELFORMAT ddpfZBuffer;
  dxd3d->EnumZBufferFormats( dxhwguid, EnumZBufferCallback, (VOID*)&ddpfZBuffer );
  status(313);
  if( sizeof(DDPIXELFORMAT) != ddpfZBuffer.dwSize )dxerror();
  status(314);
  dxsd.dwFlags        = DDSD_CAPS|DDSD_WIDTH|DDSD_HEIGHT|DDSD_PIXELFORMAT;
  dxsd.ddsCaps.dwCaps = DDSCAPS_ZBUFFER;
  dxsd.dwWidth        = XRES;
  dxsd.dwHeight       = YRES;
  memcpy( &dxsd.ddpfPixelFormat, &ddpfZBuffer, sizeof(DDPIXELFORMAT) );
  dxsd.ddsCaps.dwCaps |= DDSCAPS_VIDEOMEMORY;
  status(315);
  if( dxdd->CreateSurface( &dxsd, &dxzbuffer, NULL )!=DD_OK  )dxerror();
  status(316);
  if( dxbackbuffer->AddAttachedSurface( dxzbuffer  )!=DD_OK )dxerror();
  status(317);
/*  dxsd.ddpfPixelFormat.dwSize=sizeof(DDPIXELFORMAT);
  dxsd.ddpfPixelFormat.dwFlags=DDPF_ZBUFFER;
  dxsd.ddpfPixelFormat.dwZBufferBitDepth = 16;
  dxsd.dwFlags        = DDSD_CAPS|DDSD_WIDTH|DDSD_HEIGHT|DDSD_PIXELFORMAT;
  dxsd.dwWidth        = XRES;
  dxsd.dwHeight       = YRES;
  status(312);
  dxsd.ddsCaps.dwCaps = DDSCAPS_ZBUFFER|DDSCAPS_VIDEOMEMORY;
  if( dxdd->CreateSurface( &dxsd, &dxzbuffer, NULL )!=DD_OK){
    status(313);
    dxsd.ddsCaps.dwCaps = DDSCAPS_ZBUFFER|DDSCAPS_SYSTEMMEMORY;
    if( dxdd->CreateSurface( &dxsd, &dxzbuffer, NULL )!=DD_OK)dxerror();
    status(314);
  }
  status(315);
  if( dxbackbuffer->AddAttachedSurface( dxzbuffer )!=DD_OK)dxerror();*/
/*  ZeroMemory(&dxsd, sizeof(dxsd));
  dxsd.dwSize = sizeof(dxsd);
  dxsd.dwFlags = DDSD_CAPS | DDSD_WIDTH | DDSD_HEIGHT | DDSD_PIXELFORMAT;
  dxsd.dwWidth = XRES;
  dxsd.dwHeight = YRES;
  dxsd.ddpfPixelFormat.dwSize=sizeof(DDPIXELFORMAT);
  dxsd.ddpfPixelFormat.dwRGBBitCount = 16;
  dxsd.ddpfPixelFormat.dwZBufferBitDepth = 16;
  dxsd.ddsCaps.dwCaps = DDSCAPS_ZBUFFER | DDSCAPS_VIDEOMEMORY;
  status(312);
  if (dxdd->CreateSurface(&dxsd, &dxzbuffer, NULL) != DD_OK){
    status(313);
    dxsd.ddsCaps.dwCaps = DDSCAPS_ZBUFFER | DDSCAPS_SYSTEMMEMORY;
    if (dxdd->CreateSurface(&dxsd, &dxzbuffer, NULL) != DD_OK) dxerror();
    status(314);
  }  
  if (dxbackbuffer->AddAttachedSurface(dxzbuffer) != DD_OK) dxerror();
  status(315);*/
  // create the direct 3d device from the surface
//  if (dxd3d->CreateDevice(IID_IDirect3DTnLHALDevice,dxbackbuffer, &dxd3ddevice)!=DD_OK){
//    MessageBox(hwnd, "No TnL","Hardware notification",MB_OK);
  if (!fDeviceFound||dxd3d->CreateDevice(dxhwguid,dxbackbuffer, &dxd3ddevice)!=DD_OK){
    if(fDeviceFound)MessageBox(hwnd, "Enumerated driver failed. Trying standard hardware driver...","Hardware warning",MB_OK);
    if (dxd3d->CreateDevice(IID_IDirect3DHALDevice,dxbackbuffer, &dxd3ddevice)!=DD_OK){
      if(fDeviceFound)MessageBox(hwnd, "Standard Hardware driver failed. Trying standard MMX driver...","Hardware warning",MB_OK);
      if (dxd3d->CreateDevice(IID_IDirect3DMMXDevice,dxbackbuffer, &dxd3ddevice)!=DD_OK){
        if(fDeviceFound)MessageBox(hwnd, "Standard MMX emulation driver failed. Trying standard RGB emulation driver...","Hardware warning",MB_OK);
        if (dxd3d->CreateDevice(IID_IDirect3DRGBDevice,dxbackbuffer, &dxd3ddevice)!=DD_OK){
          if(fDeviceFound)MessageBox(hwnd, "Standard RGB emulation driver failed. Trying standard RAMP emulation driver...","Hardware warning",MB_OK);
          if (dxd3d->CreateDevice(IID_IDirect3DRampDevice,dxbackbuffer, &dxd3ddevice)!=DD_OK){
            if(fDeviceFound)MessageBox(hwnd, "Standard Ramp emulation driver failed. Trying really slow Reference Rasterizer...","Hardware warning",MB_OK);
            if (dxd3d->CreateDevice(IID_IDirect3DRefDevice,dxbackbuffer, &dxd3ddevice)!=DD_OK){
              if(fDeviceFound)MessageBox(hwnd, "Standard Reference Rasterizer driver failed. No more alternatives left. Sorry!","Hardware error",MB_OK);
              dxerror();
            }
          }
        }
      }
    }
  }
//  }
  status(318);
  // get the surface description so we know the width & height
  if (dxprimary->GetSurfaceDesc(&dxsd)!=DD_OK) dxerror();
  // create the viewport
//  if (dxd3d->CreateViewport(&dxd3dviewport, NULL)!=D3D_OK) dxerror();
  ZeroMemory(&dxviewport, sizeof(dxviewport));
//  dxviewport.dwSize = sizeof(dxviewport);
  dxviewport.dwX = 0;
  dxviewport.dwY = 0;
  dxviewport.dwWidth = XRES;
  dxviewport.dwHeight = YRES;
  dxviewport.dvMinZ = VIEWPORTMINZ;
  dxviewport.dvMaxZ = VIEWPORTMAXZ;
  if (dxd3ddevice->SetViewport(&dxviewport)!=DD_OK) dxerror();
  // textures
  status(320);
  dxinittex();
  status(321);
  // state
//  dxd3ddevice->SetRenderState(D3DRENDERSTATE_NORMALIZENORMALS,TRUE);
//  dxd3ddevice->SetRenderState(D3DRENDERSTATE_TEXTUREADDRESS, D3DTADDRESS_CLAMP);
  dxd3ddevice->SetRenderState(D3DRENDERSTATE_TEXTUREPERSPECTIVE,FALSE);
  dxd3ddevice->SetTextureStageState(0, D3DTSS_MAGFILTER, D3DTFG_LINEAR);
  dxd3ddevice->SetTextureStageState(0, D3DTSS_MINFILTER, D3DTFG_LINEAR);
  dxd3ddevice->SetRenderState(D3DRENDERSTATE_ZENABLE,TRUE);//D3DZB_USEW
  dxd3ddevice->SetRenderState(D3DRENDERSTATE_ZWRITEENABLE,TRUE);
  dxd3ddevice->SetRenderState(D3DRENDERSTATE_ZFUNC,STDCOMPFUNC);
//  dxd3ddevice->SetRenderState( D3DRENDERSTATE_AMBIENT, 0xA0A0A000 );
//  dxd3ddevice->SetRenderState( D3DRENDERSTATE_AMBIENT, 0x40404000 );
  dxd3ddevice->SetRenderState( D3DRENDERSTATE_AMBIENT, 0x00000000 );
//  dxd3ddevice->SetLightState (D3DLIGHTSTATE_AMBIENT, RGBA_MAKE(0, 0, 0, 255));
//  dxd3ddevice->SetLightState (D3DLIGHTSTATE_AMBIENT, RGBA_MAKE(80, 80, 80, 0));
//  dxd3ddevice->SetLightState (D3DLIGHTSTATE_AMBIENT, RGBA_MAKE(255, 255, 255, 255));
  dxd3ddevice->SetRenderState(D3DRENDERSTATE_LIGHTING,TRUE); 
  dxd3ddevice->SetRenderState(D3DRENDERSTATE_SPECULARENABLE,FALSE); 
//  dxd3ddevice->SetRenderState(D3DRENDERSTATE_BLENDENABLE, TRUE);
//  dxd3ddevice->SetRenderState(D3DRENDERSTATE_SRCBLEND, D3DBLEND_SRCALPHA);
//  dxd3ddevice->SetRenderState(D3DRENDERSTATE_DESTBLEND, D3DBLEND_INVSRCALPHA); 
//  dxd3ddevice->SetRenderState(D3DRENDERSTATE_EDGEANTIALIAS,TRUE);
//  dxd3ddevice->SetRenderState(D3DRENDERSTATE_FILLMODE, D3DFILL_WIREFRAME);
  matrix=D3DMATRIX(1,0,0,0, 0,1,0,0, 0,0,1,0.5, 0,0,0,1);
  dxd3ddevice->SetTransform(D3DTRANSFORMSTATE_PROJECTION, &matrix);
  matrix=D3DMATRIX(1,0,0,0, 0,1,0,0, 0,0,ZMULT,0, 0,0,ZADD,1);
  dxd3ddevice->MultiplyTransform(D3DTRANSFORMSTATE_PROJECTION, &matrix);
  dxd3ddevice->GetTransform(D3DTRANSFORMSTATE_PROJECTION, &projmtx);
  // load objects
  status(322);
  dxloadobject(&obj[0], "tank.3do");
  dxloadobject(&obj[1], "turret.3do");
  dxloadobject(&obj[2], "tank2.3do");
  dxloadobject(&obj[3], "turret2.3do");
  dxloadobject(&obj[4], "stank.3do");
  dxloadobject(&obj[5], "sturret.3do");
  dxloadobject(&obj[6], "stank2.3do");
  dxloadobject(&obj[7], "sturret2.3do");
  dxloadobject(&obj[8], "mars.3do");
  dxloadobject(&obj[9], "mturret.3do");
  dxloadobject(&obj[10], "mars2.3do");
  dxloadobject(&obj[11], "mturret2.3do");
  dxloadobject(&obj[12], "humvee.3do");
  dxloadobject(&obj[13], "hturret.3do");
  dxloadobject(&obj[14], "humvee2.3do");
  dxloadobject(&obj[15], "hturret2.3do");
  dxloadobject(&obj[16], "pritsche.3do");
  dxloadobject(&obj[17], "pturret.3do");
  dxloadobject(&obj[18], "pritsche2.3do");
  dxloadobject(&obj[19], "pturret2.3do");
  dxloadobject(&obj[20], "tonner.3do");
  dxloadobject(&obj[21], "tturret.3do");
  dxloadobject(&obj[22], "tonner2.3do");
  dxloadobject(&obj[23], "tturret2.3do");
  dxloadobject(&obj[24], "bus.3do");
  dxloadobject(&obj[25], "bturret.3do");
  dxloadobject(&obj[26], "bus2.3do");
  dxloadobject(&obj[27], "bturret2.3do");
  dxloadobject(&obj[28], "wolf.3do");
  dxloadobject(&obj[29], "wturret.3do");
  dxloadobject(&obj[30], "wolf2.3do");
  dxloadobject(&obj[31], "wturret2.3do");
  status(323);
}

void renderobj(dx3dobject* obj, float x, float y, float z, float a, float b, float c, bool dead){
//  D3DVERTEX v[3];
  // transformations
  matrix=D3DMATRIX(cos(a),sin(a),0,0, -sin(a),cos(a),0,0, 0,0,1,0, x, y, z, 1);
  dxd3ddevice->SetTransform(D3DTRANSFORMSTATE_WORLD, &matrix);
  matrix=D3DMATRIX(cos(c),0,-sin(c),0, 0,1,0,0, sin(c),0,cos(c),0, 0, 0, 0, 1);
  dxd3ddevice->MultiplyTransform(D3DTRANSFORMSTATE_WORLD, &matrix);
  matrix=D3DMATRIX(1,0,0,0, 0,cos(b),-sin(b),0, 0,sin(b),cos(b),0, 0, 0, 0, 1);
  dxd3ddevice->MultiplyTransform(D3DTRANSFORMSTATE_WORLD, &matrix);
  // drawing
  if(obj->lists>0){
    for(int i=0;i<obj->lists;i++){
//      dxd3ddevice->SetRenderState(D3DRENDERSTATE_TEXTUREHANDLE, dxhtexture[obj.list[i].tex]);
      if(dead){
        dxd3ddevice->SetTexture(0, dxstexture[10]);
      } else {
        dxd3ddevice->SetTexture(0, dxstexture[obj->list[i].tex]);
      }
      dxd3ddevice->DrawPrimitive(D3DPT_TRIANGLELIST,D3DFVF_VERTEX,&obj->list[i].v[0],obj->list[i].num,0);
    }
  }
  if(obj->strips>0){
    for(int i=0;i<obj->strips;i++){
//      dxd3ddevice->SetRenderState(D3DRENDERSTATE_TEXTUREHANDLE, dxhtexture[obj.strip[i].tex]);
      if(dead){
        dxd3ddevice->SetTexture(0, dxstexture[10]);
      } else {
        dxd3ddevice->SetTexture(0, dxstexture[obj->strip[i].tex]);
      }
      dxd3ddevice->DrawPrimitive(D3DPT_TRIANGLESTRIP,D3DFVF_VERTEX,&obj->strip[i].v[0],obj->strip[i].num,0);
    }
  }
}

void rendersecobj(dx3dobject* obj, float x, float y, float z, float a, float b, float c, float pa, float pb, float pc, bool dead){
//  D3DVERTEX v[3];
  // transformations
  matrix=D3DMATRIX(cos(pa),sin(pa),0,0, -sin(pa),cos(pa),0,0, 0,0,1,0, x, y, z, 1);
  dxd3ddevice->SetTransform(D3DTRANSFORMSTATE_WORLD, &matrix);
  matrix=D3DMATRIX(cos(pc),0,-sin(pc),0, 0,1,0,0, sin(pc),0,cos(pc),0, 0, 0, 0, 1);
  dxd3ddevice->MultiplyTransform(D3DTRANSFORMSTATE_WORLD, &matrix);
  matrix=D3DMATRIX(1,0,0,0, 0,cos(pb),-sin(pb),0, 0,sin(pb),cos(pb),0, 0, 0, 0, 1);
  dxd3ddevice->MultiplyTransform(D3DTRANSFORMSTATE_WORLD, &matrix);
  matrix=D3DMATRIX(cos(a),sin(a),0,0, -sin(a),cos(a),0,0, 0,0,1,0, 0, 0, 0, 1);
  dxd3ddevice->MultiplyTransform(D3DTRANSFORMSTATE_WORLD, &matrix);
  matrix=D3DMATRIX(cos(c),0,-sin(c),0, 0,1,0,0, sin(c),0,cos(c),0, 0, 0, 0, 1);
  dxd3ddevice->MultiplyTransform(D3DTRANSFORMSTATE_WORLD, &matrix);
  matrix=D3DMATRIX(1,0,0,0, 0,cos(b),-sin(b),0, 0,sin(b),cos(b),0, 0, 0, 0, 1);
  dxd3ddevice->MultiplyTransform(D3DTRANSFORMSTATE_WORLD, &matrix);
  // drawing
  if(obj->lists>0){
    for(int i=0;i<obj->lists;i++){
//      dxd3ddevice->SetRenderState(D3DRENDERSTATE_TEXTUREHANDLE, dxhtexture[obj.list[i].tex]);
      if(dead){
        dxd3ddevice->SetTexture(0, dxstexture[10]);
      } else {
        dxd3ddevice->SetTexture(0, dxstexture[obj->list[i].tex]);
      }
      dxd3ddevice->DrawPrimitive(D3DPT_TRIANGLELIST,D3DFVF_VERTEX,&obj->list[i].v[0],obj->list[i].num,0);
    }
  }
  if(obj->strips>0){
    for(int i=0;i<obj->strips;i++){
//      dxd3ddevice->SetRenderState(D3DRENDERSTATE_TEXTUREHANDLE, dxhtexture[obj.strip[i].tex]);
      if(dead){
        dxd3ddevice->SetTexture(0, dxstexture[10]);
      } else {
        dxd3ddevice->SetTexture(0, dxstexture[obj->strip[i].tex]);
      }
      dxd3ddevice->DrawPrimitive(D3DPT_TRIANGLESTRIP,D3DFVF_VERTEX,&obj->strip[i].v[0],obj->strip[i].num,0);
    }
  }
}

float begrf(float x, float ber){
  if(ber>0){
    while(x<0)x+=ber;
    while(x>=ber)x-=ber;
    return x;
  }else{
    return 0;
  }
}

void renderterra(void){
  D3DVERTEX vx[4];
  int i, j, tt;
  int l=-16+(int)view.px, r=16+(int)view.px, o=22+(int)view.py, u=-17+(int)view.py;
  matrix=D3DMATRIX(1,0,0,0, 0,1,0,0, 0,0,1,0, 0,0,0,1);
  dxd3ddevice->SetTransform(D3DTRANSFORMSTATE_WORLD, &matrix);
  for(j=u;j<o;j++){
//    ty=begr(j, FIELDY)*TEXY/FIELDY;
    for(i=l;i<r;i++){
//      tx=begr(i, FIELDX)*TEXX/FIELDX;
//      dxd3ddevice->SetRenderState(D3DRENDERSTATE_TEXTUREHANDLE, dxhtexture[TEXSPACEOFF+ty*TEXX+tx]);
      if(tt!=terra.tex[i][j]){
        tt=terra.tex[i][j];
        dxd3ddevice->SetTexture(0, dxstexture[tt]);
      }
//      vx[0]=D3DVERTEX(D3DVECTOR(i, j, -terra.hmap[bi][bj]/255.0*MAXHEIGHT), terra.norm[bi][bj], FXRES*1.0f/TXRES*bi-tx, FYRES*1.0f/TYRES*bj-ty);
//      vx[1]=D3DVERTEX(D3DVECTOR(i, j+1, -terra.hmap[bi][bjp]/255.0*MAXHEIGHT), terra.norm[bi][bjp], FXRES*1.0f/TXRES*bi-tx, FYRES*1.0f/TYRES*bjp-ty);
//      vx[2]=D3DVERTEX(D3DVECTOR(i+1, j, -terra.hmap[bip][bj]/255.0*MAXHEIGHT), terra.norm[bip][bj], FXRES*1.0f/TXRES*bip-tx, FYRES*1.0f/TYRES*bj-ty);
//      vx[3]=D3DVERTEX(D3DVECTOR(i+1, j+1, -terra.hmap[bip][bjp]/255.0*MAXHEIGHT), terra.norm[bip][bjp], FXRES*1.0f/TXRES*bip-tx, FYRES*1.0f/TYRES*bjp-ty);
//      dxd3ddevice->DrawPrimitive(D3DPT_TRIANGLESTRIP,D3DFVF_VERTEX,&vx[0],4,0);
      dxd3ddevice->DrawPrimitive(D3DPT_TRIANGLESTRIP,D3DFVF_VERTEX,&terra.vtx[i][j][0],4,0);
    }
  }  
}

void rendertrees(void){
  D3DVERTEX vx[4];
  D3DVECTOR v[4];
  dxd3ddevice->SetRenderState(D3DRENDERSTATE_SRCBLEND, D3DBLEND_SRCALPHA);//SRCCOLOR
  dxd3ddevice->SetRenderState(D3DRENDERSTATE_DESTBLEND, D3DBLEND_INVSRCALPHA);//INVSRCCOLOR
  //tree
  for(int i=0;i<TREES;i++){
    if(tree[i].used&&tree[i].x>view.px+LEFTEND&&tree[i].x<view.px+RIGHTEND&&tree[i].y<view.py+TOPEND&&tree[i].y>view.py+BOTTOMEND){
      matrix=D3DMATRIX(1,0,0,0, 0,1,0,0, 0,0,1,0, tree[i].x,tree[i].y,tree[i].z,1);
      dxd3ddevice->SetTransform(D3DTRANSFORMSTATE_WORLD, &matrix);
      matrix=D3DMATRIX(cos(-tree[i].a),-sin(-tree[i].a),0,0, sin(-tree[i].a),cos(-tree[i].a),0,0, 0,0,1,0, 0,0,0,1);
      dxd3ddevice->MultiplyTransform(D3DTRANSFORMSTATE_WORLD, &matrix);
      matrix=D3DMATRIX(1,0,0,0, 0,cos(tree[i].b),sin(tree[i].b),0, 0,-sin(tree[i].b),cos(tree[i].b),0, 0,0,0,1);
      dxd3ddevice->MultiplyTransform(D3DTRANSFORMSTATE_WORLD, &matrix);
      matrix=D3DMATRIX(cos(tree[i].a),-sin(tree[i].a),0,0, sin(tree[i].a),cos(tree[i].a),0,0, 0,0,1,0, 0,0,0,1);
      dxd3ddevice->MultiplyTransform(D3DTRANSFORMSTATE_WORLD, &matrix);
      dxd3ddevice->SetTexture(0, dxstexture[TREESPACEOFF+tree[i].typ]);
      v[0]=D3DVECTOR(-1, 0.5, -5);
      v[1]=D3DVECTOR(1, -0.5, -5);
      v[2]=D3DVECTOR(-1, 0.5, 0);
      v[3]=D3DVECTOR(1, -0.5, 0);
      vx[0]=D3DVERTEX(v[0], DXNORM(v[0], v[1], v[2]), 0, 0);
      vx[1]=D3DVERTEX(v[1], DXNORM(v[0], v[1], v[2]), 1, 0);
      vx[2]=D3DVERTEX(v[2], DXNORM(v[0], v[1], v[2]), 0, 1);
      vx[3]=D3DVERTEX(v[3], DXNORM(v[0], v[1], v[2]), 1, 1);
      dxd3ddevice->DrawPrimitive(D3DPT_TRIANGLESTRIP,D3DFVF_VERTEX,&vx[0],4,0);
      v[0]=D3DVECTOR(-1,-0.5, -5);
      v[1]=D3DVECTOR( 1, 0.5, -5);
      v[2]=D3DVECTOR(-1,-0.5, 0);
      v[3]=D3DVECTOR( 1, 0.5, 0);
      vx[0]=D3DVERTEX(v[0], DXNORM(v[0], v[1], v[2]), 0, 0);
      vx[1]=D3DVERTEX(v[1], DXNORM(v[0], v[1], v[2]), 1, 0);
      vx[2]=D3DVERTEX(v[2], DXNORM(v[0], v[1], v[2]), 0, 1);
      vx[3]=D3DVERTEX(v[3], DXNORM(v[0], v[1], v[2]), 1, 1);
      dxd3ddevice->DrawPrimitive(D3DPT_TRIANGLESTRIP,D3DFVF_VERTEX,&vx[0],4,0);
    }
  }
}

void rendermil(mil* milobj){
//  startprofile(12);
  D3DVECTOR mv=D3DVECTOR(0, 0, 0);
  D3DMATRIX mtx=D3DMATRIX(1,0,0,0, 0,1,0,0, 0,0,1,0, milobj->x, milobj->y, milobj->z, 1);
  mapply(&mv, mtx);
  mapply(&mv, viewmtx);
  mapply(&mv, projmtx);
  milobj->sx=mv.x;
  milobj->sy=mv.y;
//  stopprofile(12);
  if(milobj->x>view.px+LEFTEND&&milobj->x<view.px+RIGHTEND&&milobj->y<view.py+TOPEND&&milobj->y>view.py+BOTTOMEND){
//    startprofile(13);
    renderobj(&obj[milobj->owner*2+milobj->typ*4], milobj->x, milobj->y, milobj->z, milobj->a, milobj->b, milobj->c, milobj->dead);
//    stopprofile(13);
//    startprofile(14);
    rendersecobj(&obj[1+milobj->owner*2+milobj->typ*4], milobj->x, milobj->y, milobj->z,milobj->ta,milobj->tb,0, milobj->a, milobj->b, milobj->c, milobj->dead);
//    stopprofile(14);
  }
/*      dxd3ddevice->SetRenderState(D3DRENDERSTATE_ZFUNC,D3DCMP_ALWAYS);
      dxd3ddevice->SetRenderState(D3DRENDERSTATE_ZWRITEENABLE,FALSE);
      D3DMATRIX matrix=D3DMATRIX(1,0,0,0, 0,1,0,0, 0,0,1,0, 0, 0, 0, 1);
      dxd3ddevice->SetTransform(D3DTRANSFORMSTATE_VIEW, &matrix);
      matrix=D3DMATRIX(1,0,0,0, 0,1,0,0, 0,0,1,0, 0, 0, 0, 1);
      dxd3ddevice->SetTransform(D3DTRANSFORMSTATE_PROJECTION, &matrix);
//      mv.x=mv.y=mv.z=1;
      matrix=D3DMATRIX(1,0,0,0, 0,1,0,0, 0,0,1,0, mv.x, mv.y, mv.z, 1);
//      matrix=D3DMATRIX(1,0,0,0, 0,1,0,0, 0,0,1,0, 0, 0, 0, 1);
      dxd3ddevice->SetTransform(D3DTRANSFORMSTATE_WORLD, &matrix);
      D3DVERTEX vx[4];
      dxd3ddevice->SetTexture(0, dxstexture[0]);
      vx[0]=D3DVERTEX(D3DVECTOR(-0.1, -0.1, 0), D3DVECTOR(0,0,-1), 0, 0);
      vx[1]=D3DVERTEX(D3DVECTOR(-0.1, 0.1, 0), D3DVECTOR(0,0,-1), 0, 1);
      vx[2]=D3DVERTEX(D3DVECTOR(0.1, -0.1, 0), D3DVECTOR(0,0,-1), 1, 0);
      vx[3]=D3DVERTEX(D3DVECTOR(0.1, 0.1, 0), D3DVECTOR(0,0,-1), 1, 1);
      dxd3ddevice->DrawPrimitive(D3DPT_TRIANGLESTRIP,D3DFVF_VERTEX,&vx[0],4,0);
      dxd3ddevice->SetTransform(D3DTRANSFORMSTATE_VIEW, &viewmtx);
      dxd3ddevice->SetTransform(D3DTRANSFORMSTATE_PROJECTION, &projmtx);
      dxd3ddevice->SetRenderState(D3DRENDERSTATE_ZWRITEENABLE,TRUE);
      dxd3ddevice->SetRenderState(D3DRENDERSTATE_ZFUNC,STDCOMPFUNC);*/
}

void rendershot(int n){
  D3DVERTEX vx[4];
  matrix=D3DMATRIX(cos(gs.g),sin(gs.g),0,0, -sin(gs.g),cos(gs.g),0,0, 0,0,1,0, shot[n].x, shot[n].y, shot[n].z, 1);
  dxd3ddevice->SetTransform(D3DTRANSFORMSTATE_WORLD, &matrix);
  if(shot[n].typ==2){
    dxd3ddevice->SetTexture(0, NULL);
  } else{
    dxd3ddevice->SetTexture(0, dxstexture[0]);
  }
  float size;
  if(shot[n].typ==0)size=1;
  if(shot[n].typ>=1)size=0.6;
  vx[0]=D3DVERTEX(D3DVECTOR(-0.08*size, -0.08*size, 0), D3DVECTOR(0,0,-1), 0, 0);
  vx[1]=D3DVERTEX(D3DVECTOR(-0.08*size, 0.08*size, 0), D3DVECTOR(0,0,-1), 0, 1);
  vx[2]=D3DVERTEX(D3DVECTOR(0.08*size, -0.08*size, 0), D3DVECTOR(0,0,-1), 1, 0);
  vx[3]=D3DVERTEX(D3DVECTOR(0.08*size, 0.08*size, 0), D3DVECTOR(0,0,-1), 1, 1);
  dxd3ddevice->DrawPrimitive(D3DPT_TRIANGLESTRIP,D3DFVF_VERTEX,&vx[0],4,0);
}

float height(float x, float y){
  int xi, yi;
  xi=x<0?((int)x-1):(int)x;
  yi=y<0?((int)y-1):(int)y;
  return -(terra.hmap[begr(xi, FIELDX)][begr(yi, FIELDY)]*(1-(x-xi))*(1-(y-yi))
          +terra.hmap[begr(xi+1, FIELDX)][begr(yi, FIELDY)]*(x-xi)*(1-(y-yi))
          +terra.hmap[begr(xi, FIELDX)][begr(yi+1, FIELDY)]*(1-(x-xi))*(y-yi)
          +terra.hmap[begr(xi+1, FIELDX)][begr(yi+1, FIELDY)]*(x-xi)*(y-yi)
          )/255.0*MAXHEIGHT;
}

void renderparticle(int n){
  D3DLVERTEX vx[4];
//  D3DVERTEX vx[4];
  unsigned char opy;
  dxd3ddevice->SetRenderState(D3DRENDERSTATE_SRCBLEND, D3DBLEND_ONE);//SRCCOLOR
  dxd3ddevice->SetRenderState(D3DRENDERSTATE_DESTBLEND, D3DBLEND_ONE);//ONE
/*    dxd3ddevice->SetTextureStageState( 0, D3DTSS_ALPHAOP,   D3DTOP_ADDSMOOTH );
    dxd3ddevice->SetTextureStageState( 0, D3DTSS_ALPHAARG1, D3DTA_TEXTURE );
    dxd3ddevice->SetTextureStageState( 0, D3DTSS_ALPHAARG2, D3DTA_CURRENT );*/
  matrix=D3DMATRIX(1,0,0,0, 0,1,0,0, 0,0,1,0, part[n].x, part[n].y, part[n].z, 1);
  dxd3ddevice->SetTransform(D3DTRANSFORMSTATE_WORLD, &matrix);
  if(gs.g-part[n].t<PARTICLELIFE*EXPLFIRE&&part[n].typ==1){
    opy=(unsigned char)((1.0-(gs.g-part[n].t)/(PARTICLELIFE*EXPLFIRE))*255.0);
    dxd3ddevice->SetTexture(0, dxstexture[3]);
    vx[0]=D3DLVERTEX(D3DVECTOR(-0.65*part[n].size, -0.65*part[n].size, 0), RGBA_MAKE(opy,opy,opy,opy), RGBA_MAKE(0,0,0,0), 0, 0);
    vx[1]=D3DLVERTEX(D3DVECTOR(-0.65*part[n].size, 0.65*part[n].size, 0), RGBA_MAKE(opy,opy,opy,opy), RGBA_MAKE(0,0,0,0), 0, 1);
    vx[2]=D3DLVERTEX(D3DVECTOR(0.65*part[n].size, -0.65*part[n].size, 0), RGBA_MAKE(opy,opy,opy,opy), RGBA_MAKE(0,0,0,0), 1, 0);
    vx[3]=D3DLVERTEX(D3DVECTOR(0.65*part[n].size, 0.65*part[n].size, 0), RGBA_MAKE(opy,opy,opy,opy), RGBA_MAKE(0,0,0,0), 1, 1);
    dxd3ddevice->DrawPrimitive(D3DPT_TRIANGLESTRIP,D3DFVF_LVERTEX,&vx[0],4,0);
  }
  dxd3ddevice->SetRenderState(D3DRENDERSTATE_SRCBLEND, D3DBLEND_SRCCOLOR);//SRCCOLOR
  dxd3ddevice->SetRenderState(D3DRENDERSTATE_DESTBLEND, D3DBLEND_INVSRCCOLOR);//INVSRCCOLOR
  if(gs.g-part[n].t<PARTICLELIFE*EXPLFULLSMOKEBEGIN&&part[n].typ==1){
    opy=(unsigned char)(((gs.g-part[n].t)/(PARTICLELIFE*EXPLFULLSMOKEBEGIN))*255.0);
  } else {
    if(gs.g-part[n].t<PARTICLELIFE*EXPLFULLSMOKEEND){
      opy=255;
    } else {
      opy=(unsigned char)((1-(gs.g-part[n].t-PARTICLELIFE*EXPLFULLSMOKEEND)/(PARTICLELIFE*(1-EXPLFULLSMOKEEND)))*255.0);
    }
  }
  if(part[n].typ==3){
    float opyf=(1-(gs.g-part[n].t)/PARTICLELIFE3)*255.0;
    if(opyf>255.0)opyf=255.0;
    if(opyf<0.0)opyf=0.0;
    opy=(unsigned char)opyf;
  }
  dxd3ddevice->SetTexture(0, dxstexture[4]);
  vx[0]=D3DLVERTEX(D3DVECTOR(-0.65*part[n].size, -0.65*part[n].size, 0), RGBA_MAKE(opy,opy,opy,opy), RGBA_MAKE(0,0,0,0), 0, 0);
  vx[1]=D3DLVERTEX(D3DVECTOR(-0.65*part[n].size, 0.65*part[n].size, 0), RGBA_MAKE(opy,opy,opy,opy), RGBA_MAKE(0,0,0,0), 0, 1);
  vx[2]=D3DLVERTEX(D3DVECTOR(0.65*part[n].size, -0.65*part[n].size, 0), RGBA_MAKE(opy,opy,opy,opy), RGBA_MAKE(0,0,0,0), 1, 0);
  vx[3]=D3DLVERTEX(D3DVECTOR(0.65*part[n].size, 0.65*part[n].size, 0), RGBA_MAKE(opy,opy,opy,opy), RGBA_MAKE(0,0,0,0), 1, 1);
  dxd3ddevice->DrawPrimitive(D3DPT_TRIANGLESTRIP,D3DFVF_LVERTEX,&vx[0],4,0);
}

void renderoverlays(void){
  D3DLVERTEX vx[5];
  D3DMATRIX matrix=D3DMATRIX(1,0,0,0, 0,1,0,0, 0,0,1,0, 0, 0, 0, 1);
  dxd3ddevice->SetTransform(D3DTRANSFORMSTATE_VIEW, &matrix);
  matrix=D3DMATRIX(1,0,0,0, 0,1,0,0, 0,0,1,0, 0, 0, 0, 1);
  dxd3ddevice->SetTransform(D3DTRANSFORMSTATE_PROJECTION, &matrix);
  dxd3ddevice->SetRenderState(D3DRENDERSTATE_SRCBLEND, D3DBLEND_ONE);
  dxd3ddevice->SetRenderState(D3DRENDERSTATE_DESTBLEND, D3DBLEND_ONE);
  for(int i=0;i<OMILS;i++){
    if(omil[i].used){
      matrix=D3DMATRIX(1,0,0,0, 0,1,0,0, 0,0,1,0, omil[i].sx, omil[i].sy, 0, 1);
      dxd3ddevice->SetTransform(D3DTRANSFORMSTATE_WORLD, &matrix);
      unsigned char opy=64, nropy=64;
      if(omil[i].selected){
        if(omil[i].owner==1){
          opy=127;
          nropy=0;
        }  
        dxd3ddevice->SetTexture(0, NULL);
        vx[0]=D3DLVERTEX(D3DVECTOR(-0.1, -0.1, 0), RGBA_MAKE(opy,nropy,nropy,opy), RGBA_MAKE(0,0,0,0), 0, 0);
        vx[1]=D3DLVERTEX(D3DVECTOR(0.1, -0.1, 0), RGBA_MAKE(opy,nropy,nropy,opy), RGBA_MAKE(0,0,0,0), 1, 0);
        vx[2]=D3DLVERTEX(D3DVECTOR(0.1, 0.1, 0), RGBA_MAKE(opy,nropy,nropy,opy), RGBA_MAKE(0,0,0,0), 1, 1);
        vx[3]=D3DLVERTEX(D3DVECTOR(-0.1, 0.1, 0), RGBA_MAKE(opy,nropy,nropy,opy), RGBA_MAKE(0,0,0,0), 0, 1);
        vx[4]=D3DLVERTEX(D3DVECTOR(-0.1, -0.1, 0), RGBA_MAKE(opy,nropy,nropy,opy), RGBA_MAKE(0,0,0,0), 0, 0);
        dxd3ddevice->DrawPrimitive(D3DPT_LINESTRIP,D3DFVF_LVERTEX,&vx[0],5,0);
      }
      // hitpoints
      int r, g;
      opy=255;
      r=(int)((1.0-omil[i].hit/omil[i].maxhit)*(float)opy);
      g=(int)((omil[i].hit/omil[i].maxhit)*(float)opy);
      dxd3ddevice->SetTexture(0, NULL);
      vx[0]=D3DLVERTEX(D3DVECTOR(-0.1, 0.12, 0), RGBA_MAKE(r,g,0,opy), RGBA_MAKE(0,0,0,0), 0, 0);
      vx[1]=D3DLVERTEX(D3DVECTOR(-0.1+0.2*(omil[i].hit/omil[i].maxhit), 0.12, 0), RGBA_MAKE(r,g,0,opy), RGBA_MAKE(0,0,0,0), 1, 0);
      dxd3ddevice->DrawPrimitive(D3DPT_LINESTRIP,D3DFVF_LVERTEX,&vx[0],2,0);
    }
  }
  // mouse
  if(mouse.down){
    matrix=D3DMATRIX(1,0,0,0, 0,1,0,0, 0,0,1,0, 0, 0, 0, 1);
    dxd3ddevice->SetTransform(D3DTRANSFORMSTATE_WORLD, &matrix);
    POINT p;
    GetCursorPos(&p);
    unsigned char opy=64;
    dxd3ddevice->SetTexture(0, NULL);
    vx[0]=D3DLVERTEX(D3DVECTOR((2.0*mouse.downx/XRES-1), (1-2.0*mouse.downy/YRES), 0), RGBA_MAKE(opy,opy,opy,opy), RGBA_MAKE(0,0,0,0), 0, 0);
    vx[1]=D3DLVERTEX(D3DVECTOR((2.0*p.x/XRES-1), (1-2.0*mouse.downy/YRES), 0), RGBA_MAKE(opy,opy,opy,opy), RGBA_MAKE(0,0,0,0), 1, 0);
    vx[2]=D3DLVERTEX(D3DVECTOR((2.0*p.x/XRES-1), (1-2.0*p.y/YRES), 0), RGBA_MAKE(opy,opy,opy,opy), RGBA_MAKE(0,0,0,0), 1, 1);
    vx[3]=D3DLVERTEX(D3DVECTOR((2.0*mouse.downx/XRES-1), (1-2.0*p.y/YRES), 0), RGBA_MAKE(opy,opy,opy,opy), RGBA_MAKE(0,0,0,0), 0, 1);
    vx[4]=D3DLVERTEX(D3DVECTOR((2.0*mouse.downx/XRES-1), (1-2.0*mouse.downy/YRES), 0), RGBA_MAKE(opy,opy,opy,opy), RGBA_MAKE(0,0,0,0), 0, 0);
    dxd3ddevice->DrawPrimitive(D3DPT_LINESTRIP,D3DFVF_LVERTEX,&vx[0],5,0);
  }
  // stats
  stats.uservis[0]=0;
  stats.uservis[1]=1;
  unsigned char opy=64;
  matrix=D3DMATRIX(1,0,0,0, 0,1,0,0, 0,0,1,0, 0, 0, 0, 1);
  dxd3ddevice->SetTransform(D3DTRANSFORMSTATE_WORLD, &matrix);
#ifdef USERVIS
  for(int i=0;i<USERVISNUM;i++){
    dxd3ddevice->SetTexture(0, NULL);
    vx[0]=D3DLVERTEX(D3DVECTOR(-0.98, 0.98-0.02*i, 0), RGBA_MAKE(opy,opy,opy,opy), RGBA_MAKE(0,0,0,0), 0, 0);
    vx[1]=D3DLVERTEX(D3DVECTOR(-0.98+stats.uservis[i], 0.98-0.02*i, 0), RGBA_MAKE(opy,opy,opy,opy), RGBA_MAKE(0,0,0,0), 1, 0);
    dxd3ddevice->DrawPrimitive(D3DPT_LINESTRIP,D3DFVF_LVERTEX,&vx[0],2,0);
  }
#endif
#ifdef PROFILER
  float sum=0;
  for(int i=0;i<PROFILERNUM;i++){
    sum+=stats.ptime[i];
  }
  for(int i=0;i<PROFILERNUM;i++){
    if(sum!=0)stats.profiler[i]=stats.ptime[i]/sum;
    dxd3ddevice->SetTexture(0, NULL);
    vx[0]=D3DLVERTEX(D3DVECTOR(-0.98, 0.98-0.02*(i+2+USERVISNUM), 0), RGBA_MAKE(opy,opy,opy,opy), RGBA_MAKE(0,0,0,0), 0, 0);
    vx[1]=D3DLVERTEX(D3DVECTOR(-0.977+stats.profiler[i], 0.98-0.02*(i+2+USERVISNUM), 0), RGBA_MAKE(opy,opy,opy,opy), RGBA_MAKE(0,0,0,0), 1, 0);
    dxd3ddevice->DrawPrimitive(D3DPT_LINESTRIP,D3DFVF_LVERTEX,&vx[0],2,0);
  }
#endif
  // textscreens
  dxd3ddevice->SetRenderState(D3DRENDERSTATE_SRCBLEND, D3DBLEND_SRCALPHA);
  dxd3ddevice->SetRenderState(D3DRENDERSTATE_DESTBLEND, D3DBLEND_INVSRCALPHA);
  dxd3ddevice->SetRenderState(D3DRENDERSTATE_BLENDENABLE, TRUE);
  dxd3ddevice->SetRenderState(D3DRENDERSTATE_ALPHABLENDENABLE, TRUE);
//  dxd3ddevice->SetRenderState( D3DRENDERSTATE_LIGHTING, TRUE );
  if(view.menu){
    opy=255;
    dxd3ddevice->SetTexture(0, dxstexture[TEXTSPACEOFF]);
/*    D3DVERTEX vxv[4];
    D3DVECTOR vcv[4];
    vcv[0]=D3DVECTOR(-0.5,  0.5, 0);
    vcv[1]=D3DVECTOR( 0.5,  0.5, 0);
    vcv[2]=D3DVECTOR(-0.5, -0.5, 0);
    vcv[3]=D3DVECTOR( 0.5, -0.5, 0);
    vxv[0]=D3DVERTEX(vcv[0], DXNORM(vcv[0], vcv[1], vcv[2]), 0, 0);
    vxv[1]=D3DVERTEX(vcv[1], DXNORM(vcv[0], vcv[1], vcv[2]), 1, 0);
    vxv[2]=D3DVERTEX(vcv[2], DXNORM(vcv[0], vcv[1], vcv[2]), 0, 1);
    vxv[3]=D3DVERTEX(vcv[3], DXNORM(vcv[0], vcv[1], vcv[2]), 1, 1);
    dxd3ddevice->DrawPrimitive(D3DPT_TRIANGLESTRIP,D3DFVF_VERTEX,&vxv[0],4,D3DDP_DONOTLIGHT);*/
    float size=0.5;
    if(view.menutype==4)size=0.85;
    vx[0]=D3DLVERTEX(D3DVECTOR(-size,  size, 0), RGBA_MAKE(opy,opy,opy,0), RGBA_MAKE(opy,opy,opy,0), 0, 0);
    vx[1]=D3DLVERTEX(D3DVECTOR( size,  size, 0), RGBA_MAKE(opy,opy,opy,0), RGBA_MAKE(opy,opy,opy,0), 1, 0);
    vx[2]=D3DLVERTEX(D3DVECTOR(-size, -size, 0), RGBA_MAKE(opy,opy,opy,0), RGBA_MAKE(opy,opy,opy,0), 0, 1);
    vx[3]=D3DLVERTEX(D3DVECTOR( size, -size, 0), RGBA_MAKE(opy,opy,opy,0), RGBA_MAKE(opy,opy,opy,0), 1, 1);
    dxd3ddevice->DrawPrimitive(D3DPT_TRIANGLESTRIP,D3DFVF_LVERTEX,&vx[0],4,0);
  }
  // restore
  dxd3ddevice->SetTransform(D3DTRANSFORMSTATE_VIEW, &viewmtx);
  dxd3ddevice->SetTransform(D3DTRANSFORMSTATE_PROJECTION, &projmtx);
}

void render(void){
  status(200);
  startprofile(3);
  // clear zbuf, backbuf
  ZeroMemory(&dxblt, sizeof(dxblt));
  dxblt.dwSize = sizeof(dxblt);
  status(201);
  if(dxbackbuffer->Blt(NULL,NULL,NULL,/*DDBLT_WAIT|*/DDBLT_COLORFILL,&dxblt)!=DD_OK) dxerror();
  status(202);
  D3DRECT rect;
  rect.x1 = 0;rect.y1 = 0;
  rect.x2 = XRES; rect.y2 = YRES;
  status(203);
//  if(dxd3dviewport->Clear(1, &rect, D3DCLEAR_ZBUFFER)!=DD_OK) dxerror();
  if(dxd3ddevice->Clear(0, NULL, D3DCLEAR_ZBUFFER, 0, ZBCLEARVALUE, 0)!=DD_OK) dxerror();
  stopprofile(3);
  // projection
  matrix=D3DMATRIX(1/view.zoom,0,0,0, 0,1/view.zoom,0,0, 0,0,1,0, 0,0,0,1);
  dxd3ddevice->SetTransform(D3DTRANSFORMSTATE_PROJECTION, &matrix);
  matrix=D3DMATRIX(1,0,0,0, 0,1,0,0, 0,0,1,0.5, 0,0,0,1);
  dxd3ddevice->MultiplyTransform(D3DTRANSFORMSTATE_PROJECTION, &matrix);
  matrix=D3DMATRIX(1,0,0,0, 0,1,0,0, 0,0,ZMULT,0, 0,0,ZADD,1);
  dxd3ddevice->MultiplyTransform(D3DTRANSFORMSTATE_PROJECTION, &matrix);
  dxd3ddevice->GetTransform(D3DTRANSFORMSTATE_PROJECTION, &projmtx);
  // view
  status(204);
  matrix=D3DMATRIX(1,0,0,0, 0,cos(PI/4),sin(PI/4),0, 0,-sin(PI/4),cos(PI/4),0, 0,0,0,1);
  dxd3ddevice->SetTransform(D3DTRANSFORMSTATE_VIEW, &matrix);
  matrix=D3DMATRIX(1,0,0,0, 0,1,0,0, 0,0,1,0, -view.px,-view.py,0,VIEWDIV);
  dxd3ddevice->MultiplyTransform(D3DTRANSFORMSTATE_VIEW, &matrix);
  dxd3ddevice->GetTransform(D3DTRANSFORMSTATE_VIEW, &viewmtx);  
/*  matrix=D3DMATRIX(1,0,0,0, 0,1,0,0, 0,0,1,0, 0,-1,0,1);
  dxd3ddevice->MultiplyTransform(D3DTRANSFORMSTATE_VIEW, &matrix);*/
//  view.px+=0.03;
  status(205);
  // draw scene
  if (dxd3ddevice->BeginScene()!=D3D_OK) dxerror();
//  dxd3ddevice->SetRenderState(D3DRENDERSTATE_TEXTUREADDRESS, D3DTADDRESS_CLAMP);
  startprofile(12);
  dxd3ddevice->SetTextureStageState( 0, D3DTSS_ADDRESS, D3DTADDRESS_CLAMP);
  renderterra();
//  dxd3ddevice->SetRenderState(D3DRENDERSTATE_TEXTUREADDRESS, D3DTADDRESS_WRAP);
  stopprofile(12);
  dxd3ddevice->SetTextureStageState( 0, D3DTSS_ADDRESS, D3DTADDRESS_WRAP);
  status(206);
  startprofile(4);
  for(int i=0;i<OMILS;i++){
    if(omil[i].used){
      rendermil(&(omil[i]));
    }
  };
  dxd3ddevice->SetRenderState(D3DRENDERSTATE_ALPHABLENDENABLE, TRUE);
  dxd3ddevice->SetRenderState( D3DRENDERSTATE_ALPHATESTENABLE, TRUE ); 
  dxd3ddevice->SetRenderState( D3DRENDERSTATE_ALPHAREF, (DWORD)0x00202020);
  dxd3ddevice->SetRenderState( D3DRENDERSTATE_ALPHAFUNC, D3DCMP_GREATEREQUAL ); 
  for(int i=0;i<OMILS;i++){
    if(omil[i].dead){
      rendermil(&(omil[i]));
    }
  };
  dxd3ddevice->SetRenderState(D3DRENDERSTATE_ALPHABLENDENABLE, FALSE);
  dxd3ddevice->SetRenderState( D3DRENDERSTATE_ALPHATESTENABLE, FALSE ); 
  stopprofile(4);
  startprofile(5);
  status(208);
  for(int i=0;i<NUMSHOTS;i++){
    if(shot[i].used){
      rendershot(i);
    }
  };
  stopprofile(5);
  startprofile(6);
  status(210);
  // Transparente surfaces zuletzt!
  dxd3ddevice->SetRenderState(D3DRENDERSTATE_ALPHABLENDENABLE, TRUE);
  dxd3ddevice->SetRenderState( D3DRENDERSTATE_ALPHATESTENABLE, TRUE ); 
  dxd3ddevice->SetRenderState( D3DRENDERSTATE_ALPHAREF, (DWORD)0x00202020);
  dxd3ddevice->SetRenderState( D3DRENDERSTATE_ALPHAFUNC, D3DCMP_GREATEREQUAL ); 
//  dxd3ddevice->SetRenderState(D3DRENDERSTATE_COLORKEYBLENDENABLE, TRUE);
  rendertrees();
  stopprofile(6);
  startprofile(11);
  dxd3ddevice->SetRenderState( D3DRENDERSTATE_ALPHATESTENABLE, FALSE ); 
//  dxd3ddevice->SetRenderState(D3DRENDERSTATE_COLORKEYBLENDENABLE, FALSE);
//  dxd3ddevice->SetRenderState(D3DRENDERSTATE_ALPHABLENDENABLE, FALSE);
  dxd3ddevice->SetRenderState(D3DRENDERSTATE_BLENDENABLE, TRUE);
  dxd3ddevice->SetRenderState(D3DRENDERSTATE_ZWRITEENABLE,FALSE);
  dxd3ddevice->SetRenderState( D3DRENDERSTATE_LIGHTING, FALSE );
//  dxd3ddevice->SetRenderState(D3DRENDERSTATE_ZFUNC,D3DCMP_ALWAYS);
  status(211);
  for(int i=0;i<PARTICLES;i++){
    if(part[i].used&&part[i].x>view.px+LEFTEND&&part[i].x<view.px+RIGHTEND&&part[i].y<view.py+TOPEND&&part[i].y>view.py+BOTTOMEND){
      renderparticle(i);
    }  
  };
  stopprofile(11);
  status(213);
  dxd3ddevice->SetRenderState(D3DRENDERSTATE_ZFUNC,D3DCMP_ALWAYS);
  renderoverlays();// no profiles over this!!
  dxd3ddevice->SetRenderState(D3DRENDERSTATE_ZFUNC,STDCOMPFUNC);
  dxd3ddevice->SetRenderState( D3DRENDERSTATE_LIGHTING, TRUE );
  dxd3ddevice->SetRenderState(D3DRENDERSTATE_ZWRITEENABLE,TRUE);
  dxd3ddevice->SetRenderState(D3DRENDERSTATE_BLENDENABLE, FALSE);
  dxd3ddevice->SetRenderState(D3DRENDERSTATE_ALPHABLENDENABLE, FALSE);
  status(214);
  if (dxd3ddevice->EndScene()!=D3D_OK) dxerror();
  // flip buffers
  status(215);
  startprofile(7);
  if(dxprimary->Flip(NULL,DDFLIP_NOVSYNC)!=DD_OK)dxerror();//DDFLIP_NOVSYNC DDFLIP_WAIT
  status(216);
  stopprofile(7);
}

BOOL wininit(HINSTANCE hThisInstance){
  wincl.hInstance = hThisInstance;
  wincl.lpszClassName = szClassName;
  wincl.lpfnWndProc = WindowProcedure;    
  wincl.style = CS_NOCLOSE;               
  wincl.hIcon = LoadIcon(NULL, IDI_APPLICATION);
  wincl.hCursor = LoadCursor(NULL, IDC_ARROW);
  wincl.lpszMenuName = NULL;
  wincl.cbClsExtra = 0;                   
  wincl.cbWndExtra = 0;                   
  wincl.hbrBackground = (HBRUSH) GetStockObject(LTGRAY_BRUSH);
  if(!RegisterClass(&wincl)) return FALSE;
  hwnd = CreateWindowEx(
           WS_EX_TOPMOST,
           szClassName,
           "Tank 3.0",         
           WS_POPUPWINDOW,
           0,
           0,
           XRES,
           YRES, 
           HWND_DESKTOP,  
           NULL,            
           hThisInstance,    
           NULL           
           );
  ShowWindow(hwnd, SW_SHOWMAXIMIZED);
  return true;
}

void displaymenu(int n){
  view.menuscroll=0;
  view.menumaxscroll=0;
  if(view.menutype!=n)loadmenu(n);
  view.menutype=n;
  view.menu=true;
}

LRESULT CALLBACK WindowProcedure(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
  POINT p;
  GetCursorPos(&p);
  switch (message){
           case WM_DESTROY:
             PostQuitMessage(0);
           break;
           case WM_KEYDOWN:
             if(view.menutype!=2){
               if(wParam==VK_ESCAPE&&view.menu&&view.menutype==1){view.menu=false;break;}
               if(wParam==VK_ESCAPE&&(!view.menu||view.menutype!=1)){displaymenu(1);break;}
               if((wParam==0x4F||wParam==0x6F)&&view.menu&&view.menutype==0){view.menu=false;break;}
               if((wParam==0x4F||wParam==0x6F)&&(!view.menu||view.menutype!=0)){displaymenu(0);break;}
             }
             if(wParam==VK_ESCAPE&&view.menu&&view.menutype==2){view.menukilltime=gs.g-0.1;break;}
             if(wParam==0x51||wParam==0x71)PostQuitMessage(0);
           break;
           case WM_KEYUP:
           break;
           case WM_RBUTTONDOWN:
             mouse.rdown=true;
           break;
           case WM_LBUTTONDOWN:
             if(!mouse.down){
               mouse.downx=p.x;
               mouse.downy=p.y;
               mouse.down=true;
             }
           break;
           case WM_LBUTTONUP:
             mouse.up=true;
           break;
           case WM_MOUSEMOVE:
             if(((wParam&MK_LBUTTON)==MK_LBUTTON)&&!mouse.down){
               mouse.downx=p.x;
               mouse.downy=p.y;
               mouse.down=true;
             }
             if(((wParam&MK_RBUTTON)==MK_RBUTTON)&&!mouse.rdown){
               mouse.rdown=true;
             }
             if(((wParam&MK_LBUTTON)!=MK_LBUTTON)&&mouse.down&&!mouse.up){
               mouse.up=true;
             }
           break;
           default:
           return DefWindowProc(hwnd, message, wParam, lParam);
  }
  return 0;
}

void terranorm(void){
  D3DVECTOR v[8];
  int tx, ty;
  for(int j=0;j<FIELDY;j++){
    ty=begr(j, FIELDY)*TEXY/FIELDY;
    for(int i=0;i<FIELDX;i++){
      tx=begr(i, FIELDX)*TEXX/FIELDX;
      terra.tex[i][j]=TEXSPACEOFF+ty*TEXX+tx;
      v[0]=D3DVECTOR(i, j, -terra.hmap[begr(i,FIELDX)][begr(j,FIELDY)]/255.0*MAXHEIGHT);
      v[1]=D3DVECTOR(i, j+1, -terra.hmap[begr(i,FIELDX)][begr(j+1,FIELDY)]/255.0*MAXHEIGHT);
      v[2]=D3DVECTOR(i+1, j, -terra.hmap[begr(i+1,FIELDX)][begr(j,FIELDY)]/255.0*MAXHEIGHT);
      v[3]=D3DVECTOR(i+1, j+1, -terra.hmap[begr(i+1,FIELDX)][begr(j+1,FIELDY)]/255.0*MAXHEIGHT);
      v[4]=D3DVECTOR(i, j+2, -terra.hmap[begr(i,FIELDX)][begr(j+2,FIELDY)]/255.0*MAXHEIGHT);
      v[5]=D3DVECTOR(i+1, j+2, -terra.hmap[begr(i+1,FIELDX)][begr(j+2,FIELDY)]/255.0*MAXHEIGHT);
      v[6]=D3DVECTOR(i+2, j+1, -terra.hmap[begr(i+2,FIELDX)][begr(j+1,FIELDY)]/255.0*MAXHEIGHT);
      v[7]=D3DVECTOR(i+2, j, -terra.hmap[begr(i+2,FIELDX)][begr(j,FIELDY)]/255.0*MAXHEIGHT);
      terra.vtx[i][j][0]=D3DVERTEX(v[0], DXNORM(v[0], v[1], v[2]), FXRES*1.0f/TXRES*i-tx, FYRES*1.0f/TYRES*j-ty);
      terra.vtx[i][j][1]=D3DVERTEX(v[1], DXNORM(v[1], v[4], v[3]), FXRES*1.0f/TXRES*i-tx, FYRES*1.0f/TYRES*(j+1)-ty);
      terra.vtx[i][j][2]=D3DVERTEX(v[2], DXNORM(v[2], v[3], v[7]), FXRES*1.0f/TXRES*(i+1)-tx, FYRES*1.0f/TYRES*j-ty);
      terra.vtx[i][j][3]=D3DVERTEX(v[3], DXNORM(v[3], v[5], v[6]), FXRES*1.0f/TXRES*(i+1)-tx, FYRES*1.0f/TYRES*(j+1)-ty);
    }
  }
}

int toint(float a){
  if(a>=0){
    return (int)a;
  }else{
    return (int)(a-1);
  }  
}

void addpixel(float x,float y){
  int i=begr(toint(x), FIELDX)*TEXX/FIELDX;
  int j=begr(toint(y), FIELDY)*TEXY/FIELDY;
  unsigned int color;
  int br=begr(rand(),64),bg=begr(rand(),br),bb=begr(rand(),bg);
  int r, g, b;
  int tx, ty;
  dxsd.dwSize=sizeof(DDSURFACEDESC2);
  dxstexture[TEXSPACEOFF+j*TEXX+i]->GetSurfaceDesc( &dxsd );
  dxstexture[TEXSPACEOFF+j*TEXX+i]->Lock( NULL, &dxsd, DDLOCK_WAIT, 0 );
  int dsize=dxsd.ddpfPixelFormat.dwRGBBitCount;
  unsigned int *texbuf=(unsigned int*)dxsd.lpSurface;
  unsigned short *texbufw=(unsigned short*)dxsd.lpSurface;
  tx=begr(toint(x*FXRES), TXRES);
  ty=begr(toint(y*FYRES), TYRES);
//  color=GetPixel(dxtexturedc, tx, ty);
  if(dsize==16){
    color=texbufw[ty*TXRES+tx];
  } else{
    color=texbuf[ty*TXRES+tx];
  }
  r=((int)((((color&(dxttexred1*dxttexredr))/dxttexred1)/(float)dxttexredr)*255.0))-32;
  if(r<br)r=br;
  g=((int)((((color&(dxttexgreenr*dxttexgreen1))/dxttexgreen1)/(float)dxttexgreenr)*255.0))-32;
  if(g<bg)g=bg;
  b=((int)((((color&(dxttexblue1*dxttexbluer))/dxttexblue1)/(float)dxttexbluer)*255.0))-32;
  if(b<bb)b=bb;
  color=dxttexred1*(int)(((float)r/255.0)*(float)dxttexredr)
       +dxttexgreen1*(int)(((float)g/255.0)*(float)dxttexgreenr)
       +dxttexblue1*(int)(((float)b/255.0)*(float)dxttexbluer);
//  dxstexture[TEXSPACEOFF+j*TEXX+i]->GetDC(&dxtexturedc);
  if(dsize==16){
    texbufw[ty*TXRES+tx]=color;
  } else {
    texbuf[ty*TXRES+tx]=color;
  }
//  SetPixel(dxtexturedc, tx, ty, color);
//  dxstexture[TEXSPACEOFF+j*TEXX+i]->ReleaseDC(dxtexturedc);
  dxstexture[TEXSPACEOFF+j*TEXX+i]->Unlock(0);
  if(tx==0||ty==0){
    int il, jo;
    if(tx==0){il=begr(i-1, TEXX);}else{il=i;}
    if(ty==0){jo=begr(j-1, TEXY);}else{jo=j;}
    dxsd.dwSize=sizeof(DDSURFACEDESC2);
    dxstexture[TEXSPACEOFF+jo*TEXX+il]->GetSurfaceDesc( &dxsd );
    dxstexture[TEXSPACEOFF+jo*TEXX+il]->Lock( NULL, &dxsd, DDLOCK_WAIT, 0 );
    int dsize=dxsd.ddpfPixelFormat.dwRGBBitCount;
    texbuf=(unsigned int*)dxsd.lpSurface;
    texbufw=(unsigned short*)dxsd.lpSurface;
//    dxstexture[TEXSPACEOFF+jo*TEXX+il]->GetDC(&dxtexturedc);
    int otx, oty;
    if(tx==0){otx=TXRES-1;}else{otx=tx;}
    if(ty==0){oty=TYRES-1;}else{oty=ty;}
    if(dsize==16){
      texbufw[oty*TXRES+otx]=color;
    } else {
      texbuf[oty*TXRES+otx]=color;
    }
//    SetPixel(dxtexturedc, otx, oty, color);
//    dxstexture[TEXSPACEOFF+jo*TEXX+il]->ReleaseDC(dxtexturedc);
    dxstexture[TEXSPACEOFF+jo*TEXX+il]->Unlock(0);
  }
  if(tx==TXRES-1||ty==TYRES-1){
    int il, jo;
    if(tx==TXRES-1){il=begr(i+1, TEXX);}else{il=i;}
    if(ty==TYRES-1){jo=begr(j+1, TEXY);}else{jo=j;}
    dxsd.dwSize=sizeof(DDSURFACEDESC2);
    dxstexture[TEXSPACEOFF+jo*TEXX+il]->GetSurfaceDesc( &dxsd );
    dxstexture[TEXSPACEOFF+jo*TEXX+il]->Lock( NULL, &dxsd, DDLOCK_WAIT, 0 );
    int dsize=dxsd.ddpfPixelFormat.dwRGBBitCount;
    texbuf=(unsigned int*)dxsd.lpSurface;
    texbufw=(unsigned short*)dxsd.lpSurface;
//    dxstexture[TEXSPACEOFF+jo*TEXX+il]->GetDC(&dxtexturedc);
    int otx, oty;
    if(tx==TXRES-1){otx=0;}else{otx=tx;}
    if(ty==TYRES-1){oty=0;}else{oty=ty;}
    if(dsize==16){
      texbufw[oty*TXRES+otx]=color;
    } else {
      texbuf[oty*TXRES+otx]=color;
    }
//    SetPixel(dxtexturedc, otx, oty, color);
    dxstexture[TEXSPACEOFF+jo*TEXX+il]->Unlock(0);
//    dxstexture[TEXSPACEOFF+jo*TEXX+il]->ReleaseDC(dxtexturedc);
  }
}

float maxf(float x, float y){
  if(x>y)return x;
  if(x<=y)return y;
}

void pathway(float x1, float y1, float x2, float y2){
  status(1050);
  if(absf(x1-x2)>absf(y1-y2)){
    if(x1>x2){
      float x3, y3;
      x3=x1;
      y3=y1;
      x1=x2;
      y1=y2;
      x2=x3;
      y2=y3;
    }
    float step=1.0/(float)FXRES;
    status(1051);
  //  if(absf(x2-x1)!=0)step/=absf(x2-x1);
    for(int k=0;k<25;k++){
      float xp=begr(rand(), 2000)/500.0-2.0, yp=begr(rand(), 2000)/500.0-2.0;
      float xp2=xp+0.3*(begr(rand(), 2000)/500.0-2.0), yp2=yp+0.3*(begr(rand(), 2000)/500.0-2.0);
      float xp3=xp+0.3*(begr(rand(), 2000)/500.0-2.0), yp3=yp+0.3*(begr(rand(), 2000)/500.0-2.0);
  //    status(k);
      for(float i=x1;i<x2;i+=step){
        float j=(float)(i-x1)/(float)(x2-x1)*(float)(y2-y1)+y1;
        addpixel(i+xp+xp2*((float)(i-x1)/(float)(x2-x1))+xp3*(1-((float)(i-x1)/(float)(x2-x1)))
               , j+yp+yp2*((float)(i-x1)/(float)(x2-x1))+yp3*(1-((float)(i-x1)/(float)(x2-x1))));
        if(GetAsyncKeyState(VK_ESCAPE)!=0)break;
      }
      if(GetAsyncKeyState(VK_ESCAPE)!=0)break;
    }
  }
  if(absf(x1-x2)<=absf(y1-y2)){
    if(y1>y2){
      float x3, y3;
      x3=x1;
      y3=y1;
      x1=x2;
      y1=y2;
      x2=x3;
      y2=y3;
    }
    float step=1.0/(float)FYRES;
    status(1051);
   //  if(absf(x2-x1)!=0)step/=absf(x2-x1);
    for(int k=0;k<25;k++){
      float xp=begr(rand(), 2000)/500.0-2.0, yp=begr(rand(), 2000)/500.0-2.0;
      float xp2=xp+0.3*(begr(rand(), 2000)/500.0-2.0), yp2=yp+0.3*(begr(rand(), 2000)/500.0-2.0);
      float xp3=xp+0.3*(begr(rand(), 2000)/500.0-2.0), yp3=yp+0.3*(begr(rand(), 2000)/500.0-2.0);
  //    status(k);
      for(float i=y1;i<y2;i+=step){
        float j=(float)(i-y1)/(float)(y2-y1)*(float)(x2-x1)+x1;
        addpixel(j+xp+xp2*((float)(i-y1)/(float)(y2-y1))+xp3*(1-((float)(i-y1)/(float)(y2-y1)))
               , i+yp+yp2*((float)(i-y1)/(float)(y2-y1))+yp3*(1-((float)(i-y1)/(float)(y2-y1))));
        if(GetAsyncKeyState(VK_ESCAPE)!=0)break;
      }
      if(GetAsyncKeyState(VK_ESCAPE)!=0)break;
    }
  }
  status(1052);
}

void terrainit(void){
  float thmap[FIELDX*FIELDY];
  float min, max;
  struct timeb t2;
  ftime(&t2);
  srand(t2.millitm+1000*t2.time);
  status(1000);
  for(int i=0;i<FIELDX;i++){
    for(int j=0;j<FIELDY;j++){
      thmap[i*FIELDX+j]=begr(rand(), 10000);
    }
  }
  status(1001);
  int anz=2;
  for(int k=0;k<anz;k++){
    for(int i=0;i<FIELDX;i++){
      for(int j=0;j<FIELDY;j++){
        thmap[i*FIELDX+j]=(thmap[i*FIELDX+j]+thmap[begr(i+1,FIELDX)*FIELDX+j]+thmap[i*FIELDX+begr(j+1,FIELDY)]+thmap[begr(i+1,FIELDX)*FIELDX+begr(j+1,FIELDY)]
                    +thmap[begr(i-1,FIELDX)*FIELDX+j]+thmap[i*FIELDX+begr(j-1,FIELDY)]+thmap[begr(i-1,FIELDX)*FIELDX+begr(j-1,FIELDY)])/7;
      }
    }  
  }
  status(1002);
  for(int i=0;i<TERRAWAYS;i++){
    if(terra.way[i].used){
      float x3,y3;
      float x1=terra.way[i].x1, y1=terra.way[i].y1;
      float x2=terra.way[i].x2, y2=terra.way[i].y2;
      if(absf(x1-x2)>absf(y1-y2)){ // bresenham or so
        if(x1>x2){
          x3=x1;
          y3=y1;
          x1=x2;
          y1=y2;
          x2=x3;
          y2=y3;
        }
        status(1003);
        for(int i=(int)x1;i<(int)x2;i++){
          int x=i;
          int y=(int)(y1+((float)(y2-y1))*(((float)(i-x1))/((float)(x2-x1))));
          for(int k=0;k<3;k++){
            for(int i=x-3;i<x+3;i++){
              for(int j=y-3;j<y+3;j++){
                thmap[begr(i, FIELDX)*FIELDX+begr(j, FIELDY)]=(thmap[begr(i, FIELDX)*FIELDX+begr(j, FIELDY)]+thmap[begr(i+1,FIELDX)*FIELDX+begr(j, FIELDY)]+thmap[begr(i, FIELDX)*FIELDX+begr(j+1,FIELDY)]+thmap[begr(i+1,FIELDX)*FIELDX+begr(j+1,FIELDY)]
                            +thmap[begr(i-1,FIELDX)*FIELDX+begr(j, FIELDY)]+thmap[begr(i, FIELDX)*FIELDX+begr(j-1,FIELDY)]+thmap[begr(i-1,FIELDX)*FIELDX+begr(j-1,FIELDY)])/7;
              }
            }  
          }
        }
        status(1004);
      } else {
        if(y1>y2){
          x3=x1;
          y3=y1;
          x1=x2;
          y1=y2;
          x2=x3;
          y2=y3;
        }
        status(1005);
        for(int i=(int)y1;i<(int)y2;i++){
          int x=(int)(x1+((float)(x2-x1))*(((float)(i-y1))/((float)(y2-y1))));
          int y=i;
          for(int k=0;k<3;k++){
            for(int i=x-3;i<x+3;i++){
              for(int j=y-3;j<y+3;j++){
                thmap[begr(i, FIELDX)*FIELDX+begr(j, FIELDY)]=(thmap[begr(i, FIELDX)*FIELDX+begr(j, FIELDY)]+thmap[begr(i+1,FIELDX)*FIELDX+begr(j, FIELDY)]+thmap[begr(i, FIELDX)*FIELDX+begr(j+1,FIELDY)]+thmap[begr(i+1,FIELDX)*FIELDX+begr(j+1,FIELDY)]
                            +thmap[begr(i-1,FIELDX)*FIELDX+begr(j, FIELDY)]+thmap[begr(i, FIELDX)*FIELDX+begr(j-1,FIELDY)]+thmap[begr(i-1,FIELDX)*FIELDX+begr(j-1,FIELDY)])/7;
              }
            }  
          }
        }
        status(1006);
      }
      pathway(terra.way[i].x1, terra.way[i].y1, terra.way[i].x2, terra.way[i].y2);
    }
  }
  status(1007);
  min=thmap[0*FIELDX+0];
  max=thmap[0*FIELDX+0];
  for(int i=0;i<FIELDX;i++){
    for(int j=0;j<FIELDY;j++){
      if(thmap[i*FIELDX+j]>max)max=thmap[i*FIELDX+j];
      if(thmap[i*FIELDX+j]<min)min=thmap[i*FIELDX+j];
    }
  }  
  status(1008);
  for(int i=0;i<FIELDX;i++){
    for(int j=0;j<FIELDY;j++){
      terra.hmap[i][j]=(unsigned char)(((thmap[i*FIELDX+j]-min)/(max-min))*255.0);
    }
  }
}

D3DLIGHT7 partlight(int i){
  D3DLIGHT7 pdxlight;
  float intensity;
  if(gs.g-part[i].t<PARTICLELIFE*EXPLFIRE){
    intensity=1.0-(gs.g-part[i].t)/(PARTICLELIFE*EXPLFIRE);
  } else {
    intensity=0;
  }
  memset(&pdxlight, 0, sizeof(D3DLIGHT7));
  pdxlight.dltType = D3DLIGHT_POINT;
  pdxlight.dcvDiffuse.r = intensity;//*part[i].size/EXPSIZE;
  pdxlight.dcvDiffuse.g = intensity;//*part[i].size/EXPSIZE;
  pdxlight.dcvDiffuse.b = 0;
  pdxlight.dcvDiffuse.a = 0;//*part[i].size/EXPSIZE;
  pdxlight.dvAttenuation0 = 0.0;
  pdxlight.dvAttenuation1 = 0.0;
  pdxlight.dvAttenuation2 = 1.5;
  pdxlight.dvPosition.x = part[i].x;
  pdxlight.dvPosition.y = part[i].y;
  pdxlight.dvPosition.z = part[i].z;
  pdxlight.dvDirection.x = 0;
  pdxlight.dvDirection.y = 0;
  pdxlight.dvDirection.z = 0;
  pdxlight.dvRange = 8.0f/**intensity*/*part[i].size/EXPSIZE;
  if(intensity==0)pdxlight.dvRange = 0;
  return pdxlight;
}

D3DLIGHT7 shotlight(int i){
  D3DLIGHT7 pdxlight;
  memset(&pdxlight, 0, sizeof(D3DLIGHT7));
  pdxlight.dltType = D3DLIGHT_POINT;
  pdxlight.dcvDiffuse.r = 1;
  pdxlight.dcvDiffuse.g = 1;
  pdxlight.dcvDiffuse.b = 1;
  pdxlight.dvAttenuation0 = 0.0;
  pdxlight.dvAttenuation1 = 0.0;
  pdxlight.dvAttenuation2 = 3.0;
  pdxlight.dvPosition.x = shot[i].x;
  pdxlight.dvPosition.y = shot[i].y;
  pdxlight.dvPosition.z = shot[i].z;
  pdxlight.dvDirection.x = 0;
  pdxlight.dvDirection.y = 0;
  pdxlight.dvDirection.z = 0;
  pdxlight.dvRange = 2.0f;
  return pdxlight;
}

void newparticle(int typ, float x, float y, float z, float size, bool lit) {
  for(int i=0;i<PARTICLES;i++){
    if(!part[i].used){
      part[i].used=true;
      part[i].typ=typ;
      part[i].x=x;
      part[i].y=y;
      part[i].z=z;
      part[i].size=size;
      part[i].t=gs.g;//+begrf(rand()/1000.0, 0.18);
      part[i].dz=-0.005-begrf(rand()/10000.0, 0.01);
      part[i].lit=lit;
      if(lit){
        // lighting
//        dxd3d->CreateLight(&part[i].light, NULL);
//        for(int j=PARTLIGHTOFFSET;j<MAXLIGHTS+PARTLIGHTOFFSET;j++){
//          if(!lightused[j]){
            dxlight=partlight(i);
//            part[i].light->SetLight(&dxlight);
            dxd3ddevice->SetLight(i+PARTLIGHTOFFSET, &dxlight);
            dxd3ddevice->LightEnable(i+PARTLIGHTOFFSET, TRUE);
//            part[i].lightid=j;
//            lightused[]=true;
//          }
//        }
      }
      goto out;
    }
  }
  if(typ==2){
    int i=begr(rand(), PARTICLES);
    part[i].used=true;
    part[i].x=x;
    part[i].y=y;
    part[i].z=z;
    part[i].t=gs.g;
  }
  out:;
}

void shoot(int n){
  if(gs.g>omil[n].lastshot+mildsc[omil[n].typ].shotfreq){
    for(int i=0;i<NUMSHOTS;i++){
      if(!shot[i].used){
        shot[i].used=true;
        shot[i].x=omil[n].x+0.999*omil[n].tdx;
        shot[i].y=omil[n].y+0.999*omil[n].tdy;
        shot[i].z=omil[n].z-0.111+0.999*omil[n].tdz;
        shot[i].lastsmoke=gs.g;
        if(omil[n].typ!=3||begr(rand(),7)==0)newparticle(3, shot[i].x, shot[i].y, shot[i].z, 1, false);
        shot[i].split=-1;
        if(omil[n].typ==2){
          float dst=sqrt((omil[n].x-omil[omil[n].ttarget].x)*(omil[n].x-omil[omil[n].ttarget].x)
                        +(omil[n].y-omil[omil[n].ttarget].y)*(omil[n].y-omil[omil[n].ttarget].y));
          if(dst>mildsc[omil[n].typ].range*MARSRANGE){
            shot[i].split=gs.g+0.5*dst/mildsc[omil[n].typ].shotspeed;// 0.5*T
          }
        }
      float nx, ny, nz;
      // calculate heading of turret
      omil[n].tdx=0;
      omil[n].tdy=1;
      omil[n].tdz=0;
      ny=omil[n].tdy*cos(omil[n].tb)+omil[n].tdz*sin(omil[n].tb);
      nz=omil[n].tdz*cos(omil[n].tb)-omil[n].tdy*sin(omil[n].tb);
      omil[n].tdy=ny;
      omil[n].tdz=nz;
      nx=omil[n].tdx*cos(omil[n].ta)-omil[n].tdy*sin(omil[n].ta);
      ny=omil[n].tdy*cos(omil[n].ta)+omil[n].tdx*sin(omil[n].ta);
      omil[n].tdx=nx;
      omil[n].tdy=ny;
      ny=omil[n].tdy*cos(omil[n].b)+omil[n].tdz*sin(omil[n].b);
      nz=omil[n].tdz*cos(omil[n].b)-omil[n].tdy*sin(omil[n].b);
      omil[n].tdy=ny;
      omil[n].tdz=nz;
      nx=omil[n].tdx*cos(omil[n].c)+omil[n].tdz*sin(omil[n].c);
      nz=omil[n].tdz*cos(omil[n].c)-omil[n].tdx*sin(omil[n].c);
      omil[n].tdx=nx;
      omil[n].tdz=nz;
      nx=omil[n].tdx*cos(omil[n].a)-omil[n].tdy*sin(omil[n].a);
      ny=omil[n].tdy*cos(omil[n].a)+omil[n].tdx*sin(omil[n].a);
      omil[n].tdx=nx;
      omil[n].tdy=ny;
        shot[i].dx=omil[n].tdx*mildsc[omil[n].typ].shotspeed;
        shot[i].dy=omil[n].tdy*mildsc[omil[n].typ].shotspeed;
        shot[i].dz=omil[n].tdz*mildsc[omil[n].typ].shotspeed;
        shot[i].t=gs.g;
        shot[i].typ=omil[n].typ;
        shot[i].owner=omil[n].owner;
        shot[i].tank=n;
#ifndef DISABLESHOTLIGHTING
        // lighting
//        dxd3d->CreateLight(&shot[i].light, NULL);
        dxlight=shotlight(i);
//        shot[i].light->SetLight(&dxlight);
        dxd3ddevice->SetLight(SHOTLIGHTOFFSET+i, &dxlight);
        dxd3ddevice->LightEnable(SHOTLIGHTOFFSET+i, TRUE);
//        dxd3dviewport->AddLight(shot[i].light);
#endif
        if(omil[n].typ==2){
          play(3);
        } else {
          if(omil[n].typ>=3){
            play(2);
          } else {
           play(0);
          }
        }
        break;
      }
    }
    omil[n].lastshot=gs.g;
  }
}

void killshot(int n){
  shot[n].used=false;
#ifndef DISABLESHOTLIGHTING
  dxd3ddevice->LightEnable(SHOTLIGHTOFFSET+n, FALSE);
  dxd3ddevice->SetLight(SHOTLIGHTOFFSET+n, NULL);
  RELEASE(shot[n].light);
#endif
}

void removelight(int n){
  dxd3ddevice->LightEnable(n+PARTLIGHTOFFSET, FALSE);
//  dxd3ddevice->SetLight(n+PARTLIGHTOFFSET, NULL);
  part[n].lit=false;
//  dxd3dviewport->DeleteLight(part[n].light);
//  RELEASE(part[n].light);
}

void killparticle(int n){
  removelight(n);
  part[n].used=false;
}

void killgame(void){
    for(int i=0;i<OMILS;i++){
      omil[i].used=false;
    }
    for(int i=0;i<NUMSHOTS;i++){
      if(shot[i].used)killshot(i);
      shot[i].used=false;
    }
    for(int i=0;i<PARTICLES;i++){
      if(part[i].used)killparticle(i);
      part[i].used=false;
    }
}

void treeinit(void){
  for(int i=0;i<TREES;i++){
    tree[i].x=begr(rand(), FIELDX);
    tree[i].y=begr(rand(), FIELDY);
    tree[i].a=0;
    tree[i].b=0;
    tree[i].z=-terra.hmap[begr((int)tree[i].x,FIELDX)][begr((int)tree[i].y,FIELDY)]/255.0*MAXHEIGHT;
    tree[i].typ=begr(rand(), 4);
    tree[i].used=true;
    tree[i].falling=false;
  }
}

void loadmission(char *fname) {
  status(1400);
  mission.name[0]=0;
  mission.namelen=0;
  mission.next[0]=0;
  mission.nextlen=0;
  mission.light[0].x=0;
  mission.light[0].y=0;
  mission.light[0].z=1;
  mission.light[0].r=0;
  mission.light[0].g=0.4;
  mission.light[0].b=1.0;
  mission.light[1].x=1;
  mission.light[1].y=0;
  mission.light[1].z=0.5;
  mission.light[1].r=1.0;
  mission.light[1].g=0.6;
  mission.light[1].b=0.0;
  for(int i=0;i<ORDERLINES;i++){
    mission.orders[i][0]=0;
    mission.orderlen[i]=0;
  }
  int ordlen=0;
  mission.numomil=0;
  mission.goal.survive=-1;
  int ordlines=0;
  status(1401);
  if(mission.omildesc!=NULL)free(mission.omildesc);
  status(1402);
  FILE *f;
  unsigned short typ;
  status(1403);
  f=fopen(fname, "rb");
  status(1404);
  fseek(f, 0, SEEK_END);
  status(1405);
  int size=ftell(f);
  fseek(f, 0, SEEK_SET);
  status(1406);
  while(/*!feof(f)*/ftell(f)<size){
    status(1407);
    fread(&typ, 2, 1, f);
    status(1408);
    float fl;
    if(typ==1){
      status(1409);
      unsigned char c;
      int len=1;
      fread(&c, 1, 1, f);
//      mission.name=(char*)malloc(40);
      status(1410);
      mission.name[0]=c;
      mission.name[1]=0;
      while(c!=0){
        status(1411);
        fread(&c, 1, 1, f);
        status(1412);
        if(len<=STRINGLEN-2)len++;
//        realloc(mission.name, len+1);
        mission.name[len-1]=c;
        mission.name[len]=0;
        status(1413);
      }
      status(1414);
      mission.namelen=len-1;
    }
    status(1415);
    if(typ==6){
      unsigned char c;
      int len=1;
      status(1416);
      fread(&c, 1, 1, f);
      status(1417);
//      mission.name=(char*)malloc(40);
      mission.next[0]=c;
      mission.next[1]=0;
      status(1418);
      while(c!=0){
        status(1419);
        fread(&c, 1, 1, f);
        status(1420);
        if(len<=STRINGLEN-2)len++;
//        realloc(mission.name, len+1);
        mission.next[len-1]=c;
        mission.next[len]=0;
        status(1421);
      }
      status(1422);
      mission.nextlen=len-1;
      status(1423);
    }
    status(1424);
    if(typ==3){
      status(1425);
      unsigned char c;
      fread(&c, 1, 1, f);
      status(1426);
      ordlen++;
//      mission.orders[ordlines]=(char*)malloc(40);
//      else{
//        realloc(mission.orders[ordlines], ordlen+1);
//      }
      mission.orders[ordlines][ordlen-1]=c;
      mission.orders[ordlines][ordlen]=0;
      status(1427);
      while(c!=0){
        status(1428);
        fread(&c, 1, 1, f);
        status(1429);
        if(ordlen<=STRINGLEN-2)ordlen++;
        status(1430);
        realloc(mission.orders[ordlines], ordlen+1);
        status(1431);
        mission.orders[ordlines][ordlen-1]=c;
        status(1432);
        mission.orders[ordlines][ordlen]=0;
        status(1433);
      }
      status(1434);
      mission.orderlen[ordlines]=ordlen-1;
      status(1435);
      ordlines++;
      ordlen=0;
      status(1436);
    }
    status(1437);
    if(typ==2){
      status(1438);
      mission.numomil++;
      status(1439);
      if(mission.omildesc==NULL){
        status(1440);
        mission.omildesc=(tomildesc*)malloc(sizeof(tomildesc));
        status(1441);
      } else {
        status(1442);
        realloc(mission.omildesc, sizeof(tomildesc)*mission.numomil);
        status(1443);
      }
      status(1444);
      fread(&fl, 4, 1, f);
      status(1445);
      mission.omildesc[mission.numomil-1].owner=(int)fl;
      status(1446);
      fread(&fl, 4, 1, f);
      mission.omildesc[mission.numomil-1].typ=(int)fl;
      status(1447);
      fread(&fl, 4, 1, f);
      mission.omildesc[mission.numomil-1].posx=(int)fl;
      status(1448);
      fread(&fl, 4, 1, f);
      mission.omildesc[mission.numomil-1].posy=(int)fl;
      status(1449);
      mission.omildesc[mission.numomil-1].target=-1;
      status(1450);
    }
    status(1451);
    if(typ==4){
      status(1452);
      float x1,y1,x2,y2;
      status(1453);
      fread(&x1, 4, 1, f);
      fread(&y1, 4, 1, f);
      fread(&x2, 4, 1, f);
      fread(&y2, 4, 1, f);
      status(1454);
      for(int i=0;i<TERRAWAYS;i++){
        if(!terra.way[i].used){
          status(1455);
          terra.way[i].x1=x1;
          terra.way[i].y1=y1;
          terra.way[i].x2=x2;
          terra.way[i].y2=y2;
          terra.way[i].used=true;
          status(1456);
          break;
        }
        status(1457);
      }
      status(1458);
    }
    status(1459);
    if(typ==7){
      status(1460);
      fread(&mission.light[0].x, 4, 1, f);
      fread(&mission.light[0].y, 4, 1, f);
      fread(&mission.light[0].z, 4, 1, f);
      fread(&mission.light[0].r, 4, 1, f);
      fread(&mission.light[0].g, 4, 1, f);
      fread(&mission.light[0].b, 4, 1, f);
      fread(&mission.light[1].x, 4, 1, f);
      fread(&mission.light[1].y, 4, 1, f);
      fread(&mission.light[1].z, 4, 1, f);
      fread(&mission.light[1].r, 4, 1, f);
      fread(&mission.light[1].g, 4, 1, f);
      fread(&mission.light[1].b, 4, 1, f);
      status(1461);
    }
    status(1462);
    if(typ==5){
      status(1463);
      fread(&fl, 4, 1, f);
      mission.goal.survive=(int)fl;
      fread(&fl, 4, 1, f);
      mission.goal.kill=(int)fl;
      fread(&fl, 4, 1, f);
      mission.goal.killall=fl==-1?false:true;
      fread(&fl, 4, 1, f);
      mission.goal.location=fl==-1?false:true;
      fread(&fl, 4, 1, f);
      mission.goal.killlocation=fl==-1?false:true;
      fread(&fl, 4, 1, f);
      mission.goal.ban=fl==-1?false:true;
      status(1464);
      fread(&mission.goal.gotox, 4, 1, f);
      fread(&mission.goal.gotoy, 4, 1, f);
      fread(&mission.goal.radius, 4, 1, f);
      fread(&mission.goal.killx, 4, 1, f);
      fread(&mission.goal.killy, 4, 1, f);
      fread(&mission.goal.killradius, 4, 1, f);
      fread(&mission.goal.banx, 4, 1, f);
      fread(&mission.goal.bany, 4, 1, f);
      fread(&mission.goal.banradius, 4, 1, f);
      status(1465);
    }
    if(typ==8){
      mission.numomil++;
      status(1466);
      if(mission.omildesc==NULL){
        status(1467);
        mission.omildesc=(tomildesc*)malloc(sizeof(tomildesc));
        status(1468);
      } else {
        status(1469);
        realloc(mission.omildesc, sizeof(tomildesc)*mission.numomil);
        status(1470);
      }
      status(1471);
      fread(&fl, 4, 1, f);
      mission.omildesc[mission.numomil-1].owner=(int)fl;
      fread(&fl, 4, 1, f);
      mission.omildesc[mission.numomil-1].typ=(int)fl;
      fread(&fl, 4, 1, f);
      mission.omildesc[mission.numomil-1].posx=(int)fl;
      fread(&fl, 4, 1, f);
      mission.omildesc[mission.numomil-1].posy=(int)fl;
      fread(&fl, 4, 1, f);
      mission.omildesc[mission.numomil-1].target=(int)fl;
      fread(&fl, 4, 1, f);
      mission.omildesc[mission.numomil-1].targetx=(int)fl;
      fread(&fl, 4, 1, f);
      mission.omildesc[mission.numomil-1].targety=(int)fl;
      status(1472);
    }
    status(1472);
//    if(typ==0)break;
  }
  status(1473);
  mission.done=false;
  status(1474);
//  status(mission.numomil);
//  dxerror();
  fclose(f);
  status(1475);
  inittexttex();
  status(1476);
}

void gameinit(void){
  // time
  gs.c=1/25;
  struct timeb t2;
  ftime(&t2);
  float f2=0.001*(1000*t2.time+t2.millitm);
  gs.t=f2;
  gs.g=0;
  for(int i=0;i<NUMSHOTS;i++)if(shot[i].used)killshot(i);
  for(int i=0;i<OMILS;i++){omil[i].used=false;omil[i].dead=false;}
  for(int i=0;i<TREES;i++)tree[i].used=false;
  for(int i=0;i<PARTICLES;i++)if(part[i].used)killparticle(i);
  for(int i=0;i<TERRAWAYS;i++)terra.way[i].used=false;
  mission.success=false;
  mission.done=false;
//  for(int i=0;i<PARTICLES;i++)dxd3ddevice->LightEnable(i+PARTLIGHTOFFSET, FALSE);
  initgreen();
  status(1300);
  loadmission(mission.fname);
  status(1301);
  // lighting
  dxinitlight();
  status(1302);
//  dxinitlight();
  terrainit();
  status(1302);
  terranorm();
  status(1304);
  for(int i=0;i<min(mission.numomil, OMILS);i++){
    omil[i].owner=mission.omildesc[i].owner;
    omil[i].target=-1;
    omil[i].ttarget=-1;
    omil[i].lastfoot=gs.g;
    omil[i].lastshot=gs.g;
    omil[i].typ=mission.omildesc[i].typ;
    omil[i].x=mission.omildesc[i].posx;
    omil[i].y=mission.omildesc[i].posy;
    omil[i].target=mission.omildesc[i].target;
    omil[i].targetx=mission.omildesc[i].targetx;
    omil[i].targety=mission.omildesc[i].targety;
    omil[i].a=begrf(rand()*0.1,2*PI);
    omil[i].tb=PI/8;
    omil[i].hit=mildsc[omil[i].typ].hitpoints;
    omil[i].maxhit=omil[i].hit;
    omil[i].used=true;
    omil[i].selected=false;
  }
  status(1305);
  view.px=FIELDX/2+FIELDX/TEXX/2;
  view.py=FIELDY/2+FIELDY/TEXY/2;
  view.zoom=1;
  view.menutype=0;
  status(1306);
  displaymenu(0);
  status(1307);
  treeinit();
  status(1308);
}

void mouseinput(void){
  POINT p;
  GetCursorPos(&p);
  if(!view.menu){
   // scroll
   if(p.x<10)view.px-=15*gs.c*view.zoom;
   if(p.y<10)view.py+=15*gs.c*view.zoom;
   if(p.x>XRES-10)view.px+=15*gs.c*view.zoom;
   if(p.y>YRES-10)view.py-=15*gs.c*view.zoom;
   if(view.px<-LEFTEND)view.px=-LEFTEND;
   if(view.px>FIELDX-RIGHTEND)view.px=FIELDX-RIGHTEND;
   if(view.py<-BOTTOMEND)view.py=-BOTTOMEND;
   if(view.py>FIELDY-TOPEND)view.py=FIELDY-TOPEND;
   if(mouse.rdown){
    for(int i=0;i<OMILS;i++){
      omil[i].selected=false;
    }
    mouse.rdown=false;
   }
   if(mouse.up){
    if(abs(p.x-mouse.downx)<20&&abs(p.y-mouse.downy)<20){
      // Klick
      bool sel=false;
      bool selopp=false;
      int opp=-1;
      for(int i=0;i<OMILS;i++){
        if(omil[i].used){
          if(absf(omil[i].sx-(2.0*p.x/XRES-1))<0.1&&absf(omil[i].sy-(1-2.0*p.y/YRES))<0.1){
            sel=true;
            if(omil[i].owner==1){
              selopp=true;
              opp=i;
            }
          }
        }
      }
      if(sel){
        // tank
        if(!selopp){
          for(int i=0;i<OMILS;i++){
            if(omil[i].used){
              if(absf(omil[i].sx-(2.0*p.x/XRES-1))<0.1&&absf(omil[i].sy-(1-2.0*p.y/YRES))<0.1){
                omil[i].selected=true;
              } else {
                omil[i].selected=false;
              }
            }
          }
        } else {
          sel=false;
          for(int i=0;i<OMILS;i++){
            if(omil[i].used){
              if(omil[i].selected&&omil[i].owner==0){
                omil[i].target=opp;
                omil[i].ttarget=opp;
                sel=true;
              }
            }
          }
          if(!sel){
            for(int i=0;i<OMILS;i++){
              if(i==opp){
                omil[i].selected=true;
              } else {
                omil[i].selected=false;
              }
            }
          }
        }
      } else {
        // waypoint
        int num=0;
        float mx=0, my=0;
        for(int i=0;i<OMILS;i++){
          if(omil[i].used){
            if(omil[i].selected&&omil[i].owner==0){
              num++;
              mx+=omil[i].x;
              my+=omil[i].y;
            }
          }
        }
        if(num!=0){
          mx/=num;
          my/=num;
        }
        for(int i=0;i<OMILS;i++){
          if(omil[i].used){
            if(omil[i].selected&&omil[i].owner==0){
              omil[i].target=-2;
              omil[i].targetx=view.px+view.zoom*(2.0*p.x/XRES-1)*1.5*VIEWDIV*0.2*(5+(1-2.0*p.y/YRES));
              omil[i].targety=view.py+view.zoom*(1-2.0*p.y/YRES)*2*VIEWDIV;
              omil[i].targetx+=omil[i].x-mx;
              omil[i].targety+=omil[i].y-my;
            }
          }
        }
      }
    } else {
      // Ziehen
      for(int i=0;i<OMILS;i++){
        if(omil[i].used){
          if(mouse.downx>p.x){
            int sw=p.x;
            p.x=mouse.downx;
            mouse.downx=sw;
          }
          if(mouse.downy<p.y){
            int sw=p.y;
            p.y=mouse.downy;
            mouse.downy=sw;
          }
          if(omil[i].sx<(2.0*p.x/XRES-1)&&omil[i].sx>(2.0*mouse.downx/XRES-1)
           &&omil[i].sy<(1-2.0*p.y/YRES)&&omil[i].sy>(1-2.0*mouse.downy/YRES)
           &&omil[i].owner==0){
            omil[i].selected=true;
          } else {
            omil[i].selected=false;
          }
        }
      }
    }
    mouse.down=false;
   }
   mouse.up=false;
  } else { // if view.menu
    if(mouse.down){
      float x=((2.0*p.x)/XRES-1.0),y=(1.0-(2.0*p.y)/YRES);
      float xt=(x+0.5)*256,yt=(-y+0.5)*256;
      if(view.menutype==1){
        if(yt>50&&yt<70&&xt>0&&xt<256){
          displaymenu(0);
          goto out;
        }
        if(yt>70&&yt<90&&xt>0&&xt<256){
          displaymenu(3);
          goto out;
        }
        if(yt>90&&yt<110&&xt>0&&xt<256){
          displaymenu(4);
          goto out;
        }
        if(yt>110&&yt<130&&xt>0&&xt<256){
          PostQuitMessage(0);
          goto out;
        }
      }
      if(view.menutype==3){
        for(int i=0;i<DISPLAYEDMISSIONS;i++){
          if(yt>50+20*i&&yt<70+20*i&&xt>0&&xt<230){
            if(strlen(view.mfnames[i])>0){
              strcpy(mission.fname, view.mfnames[i]);
              killgame();
              gameinit();
              goto out;
            }
          }
        }
        if(yt>108&&yt<118&&xt>240&&xt<250){
          if(view.menuscroll>0){
            view.menuscroll--;
            loadmenu(3);
            goto out;
          }
        }
        if(yt>138&&yt<148&&xt>240&&xt<250){
          if(view.menuscroll<view.menumaxscroll){
            view.menuscroll++;
            loadmenu(3);
            goto out;
          }
        }
      }
    }
    out:
    mouse.down=false;
    mouse.rdown=false;
    mouse.up=false;
  }
}

void input(void){
  mouseinput();
/*  omil[0].sp=0;*/
  if(GetAsyncKeyState(0x6B)!=0){view.zoom-=gs.c*0.3;}
  if(GetAsyncKeyState(0x6D)!=0){view.zoom+=gs.c*0.3;}
  if(view.zoom<0.2)view.zoom=0.2;
  if(view.zoom>1)view.zoom=1;
/*  omil[0].da=0;
  if(GetAsyncKeyState(0x25)!=0){omil[0].da=0.6*TURNSPEED;}
  if(GetAsyncKeyState(0x27)!=0){omil[0].da=-0.6*TURNSPEED;}
  if(omil[0].sp<0)omil[0].da=-omil[0].da;
  if(GetAsyncKeyState(0x20)!=0)shoot(0);*/
/*  if((GetAsyncKeyState(0x27)&128==128||GetAsyncKeyState(0x27)&1==1)){shoot(0);}
  if((GetAsyncKeyState(0x0D)&128==128||GetAsyncKeyState(0x0D)&1==1)){shoot(0);}*/
}

float minf(float a, float b){
  if(a<b){
    return a;
  }else{
    return b;
  }
}

void attack(int n, int tgt){
  omil[n].target=tgt;
  omil[n].ttarget=tgt;
  omil[n].hitting=true;
  int num=0;
  for(int i=0;i<OMILS;i++){
    if(i!=n&&omil[i].used&&omil[i].owner==omil[n].owner&&omil[i].target==-1&&omil[i].ttarget==-1){
      float dst=sqrt((omil[n].x-omil[i].x)*(omil[n].x-omil[i].x)
                    +(omil[n].y-omil[i].y)*(omil[n].y-omil[i].y));
      if(dst<GROUPATTACKDST){
        omil[i].target=tgt;
        omil[i].ttarget=tgt;
        omil[i].hitting=true;
        num++;
      }
    }
    if(num>=GROUPATTACKNUM)break;
  }
}

void ki(int n){
  // target
  if(omil[n].owner!=0&&omil[n].target==-1){
    for(int i=0;i<OMILS;i++){
      if(omil[i].used&&i!=n&&omil[i].owner!=omil[n].owner){
        float dst=sqrt((omil[i].x-omil[n].x)*(omil[i].x-omil[n].x)+(omil[i].y-omil[n].y)*(omil[i].y-omil[n].y));
        if(dst<mildsc[omil[n].typ].range){
          attack(n, i);
        }
      }
    }
  }
  // ttarget
  if(omil[n].ttarget==-1){
    for(int i=0;i<OMILS;i++){
      if(omil[i].used&&i!=n&&omil[i].owner!=omil[n].owner){
        float dst=sqrt((omil[i].x-omil[n].x)*(omil[i].x-omil[n].x)+(omil[i].y-omil[n].y)*(omil[i].y-omil[n].y));
        if(dst<mildsc[omil[n].typ].range){
//          omil[n].hitting=true;
          omil[n].ttarget=i;
        }
      }
    }
  }
  // MARS target
  if(omil[n].typ==2&&omil[n].target!=-1){
    float dst=sqrt((omil[omil[n].target].x-omil[n].x)*(omil[omil[n].target].x-omil[n].x)+(omil[omil[n].target].y-omil[n].y)*(omil[omil[n].target].y-omil[n].y));
    if(dst<mildsc[omil[n].typ].range*MARSRANGE){
      for(int i=0;i<OMILS;i++){
        if(omil[i].used&&i!=n&&omil[i].owner!=omil[n].owner){
          float dst=sqrt((omil[i].x-omil[n].x)*(omil[i].x-omil[n].x)+(omil[i].y-omil[n].y)*(omil[i].y-omil[n].y));
          if(dst<mildsc[omil[n].typ].range&&dst>mildsc[omil[n].typ].range*MARSRANGE){
            attack(n, i);
          }
        }
      }
    }
  }
  // MARS ttarget
  if(omil[n].typ==2&&omil[n].ttarget!=-1){
    float dst=sqrt((omil[omil[n].ttarget].x-omil[n].x)*(omil[omil[n].ttarget].x-omil[n].x)+(omil[omil[n].ttarget].y-omil[n].y)*(omil[omil[n].ttarget].y-omil[n].y));
    if(dst<mildsc[omil[n].typ].range*MARSRANGE){
      for(int i=0;i<OMILS;i++){
        if(omil[i].used&&i!=n&&omil[i].owner!=omil[n].owner){
          float dst=sqrt((omil[i].x-omil[n].x)*(omil[i].x-omil[n].x)+(omil[i].y-omil[n].y)*(omil[i].y-omil[n].y));
          if(dst<mildsc[omil[n].typ].range&&dst>mildsc[omil[n].typ].range*MARSRANGE){
            omil[n].ttarget=i;
          }
        }
      }
    }
  }
  // Tank
  // waiting
  if(omil[n].target==-1){
    omil[n].sp=0;
    omil[n].da=0;
    omil[n].tb*=0.8;
  }
  float atot, tatot, aot, taot;
  // waypoint
  if(omil[n].target==-2){
    // Richtung des Ziels
    if(omil[n].targety-omil[n].y!=0){
      atot=atan((omil[n].x-omil[n].targetx)/(omil[n].targety-omil[n].y));
    }else{
      atot=atan((omil[n].x-omil[n].targetx)*(1E20));
    }
    if(omil[n].targety<omil[n].y)atot=atot+PI;
    float posd=100, negd=100, aot;
    if(atot-omil[n].a>0&&atot-omil[n].a<posd)posd=atot-omil[n].a;
    if(omil[n].a-atot>0&&omil[n].a-atot<negd)negd=omil[n].a-atot;
    if(atot-omil[n].a+2*PI>0&&atot-omil[n].a+2*PI<posd)posd=atot-omil[n].a+2*PI;
    if(omil[n].a-atot+2*PI>0&&omil[n].a-atot+2*PI<negd)negd=omil[n].a-atot+2*PI;
    if(atot-omil[n].a-2*PI>0&&atot-omil[n].a-2*PI<posd)posd=atot-omil[n].a-2*PI;
    if(omil[n].a-atot-2*PI>0&&omil[n].a-atot-2*PI<negd)negd=omil[n].a-atot-2*PI;
    omil[n].da=0;
    if(posd<negd){
      omil[n].da=minf(0.6*TURNSPEED, posd*3);
      aot=posd;
    }else{
      omil[n].da=-minf(0.6*TURNSPEED, negd*3);
      aot=-negd;
    }
    float dstsq=((omil[n].targety-omil[n].y)*(omil[n].targety-omil[n].y)
                +(omil[n].targetx-omil[n].x)*(omil[n].targetx-omil[n].x));
    omil[n].sp=0;
    if(dstsq>0.5&&absf(aot)<PI/4){
      omil[n].sp=mildsc[omil[n].typ].maxspeed;
    } else {
      omil[n].sp=0;
    }
    if(dstsq<=0.5){
      omil[n].target=-1;
    }
  }
  // attack
  if(omil[n].target>=0){
    if(omil[omil[n].target].y-omil[n].y!=0){
      atot=atan((omil[n].x-omil[omil[n].target].x)/(omil[omil[n].target].y-omil[n].y));
    }else{
      atot=atan((omil[n].x-omil[omil[n].target].x)*(1E20));
    }
    if(omil[omil[n].target].y<omil[n].y)atot=atot+PI;
    float posd=100, negd=100;
    if(atot-omil[n].a>0&&atot-omil[n].a<posd)posd=atot-omil[n].a;
    if(omil[n].a-atot>0&&omil[n].a-atot<negd)negd=omil[n].a-atot;
    if(atot-omil[n].a+2*PI>0&&atot-omil[n].a+2*PI<posd)posd=atot-omil[n].a+2*PI;
    if(omil[n].a-atot+2*PI>0&&omil[n].a-atot+2*PI<negd)negd=omil[n].a-atot+2*PI;
    if(atot-omil[n].a-2*PI>0&&atot-omil[n].a-2*PI<posd)posd=atot-omil[n].a-2*PI;
    if(omil[n].a-atot-2*PI>0&&omil[n].a-atot-2*PI<negd)negd=omil[n].a-atot-2*PI;
    omil[n].da=0;
    if(posd<negd){
      omil[n].da=minf(0.6*TURNSPEED, posd*3);
      aot=posd;
    }else{
      omil[n].da=-minf(0.6*TURNSPEED, negd*3);
      aot=-negd;
    }
    float dst=sqrt((omil[omil[n].target].y-omil[n].y)*(omil[omil[n].target].y-omil[n].y)
                  +(omil[omil[n].target].x-omil[n].x)*(omil[omil[n].target].x-omil[n].x));
    omil[n].sp=0;
    if(((!omil[n].hitting)&&omil[n].typ!=2)||dst>mildsc[omil[n].typ].range){
/*      if(omil[n].hitting){
        omil[n].sp=minf(1.0*TANKSPEED, dst-5);
      } else {*/
        omil[n].sp=minf(mildsc[omil[n].typ].maxspeed, dst);
//      }
    }
  }
  // turret
  if(omil[n].ttarget>=0){
    // virtuelle Position des Turm-Ziels
    float tgtx, tgty, tgtz, nx, ny, nz;
    tgtx=omil[omil[n].ttarget].x-omil[n].x;
    tgty=omil[omil[n].ttarget].y-omil[n].y;
    tgtz=omil[omil[n].ttarget].z-omil[n].z;
    float dst=sqrt(tgtx*tgtx+tgty*tgty+tgtz*tgtz);
    nx=tgtx*cos(-omil[n].a)-tgty*sin(-omil[n].a);
    ny=tgty*cos(-omil[n].a)+tgtx*sin(-omil[n].a);
    tgtx=nx;
    tgty=ny;
    nx=tgtz*sin(-omil[n].c)+tgtx*cos(-omil[n].c);
    nz=tgtz*cos(-omil[n].c)-tgtx*sin(-omil[n].c);
    tgtx=nx;
    tgtz=nz;
    ny=tgtz*sin(-omil[n].b)+tgty*cos(-omil[n].b);
    nz=tgtz*cos(-omil[n].b)-tgty*sin(-omil[n].b);
    tgty=ny;
    tgtz=nz;
    tgtx+=omil[n].x;
    tgty+=omil[n].y;
    tgtz+=omil[n].z;
    float speed;
    tgtz-=0.9*0.5*SHOTGRAVITY*(dst/mildsc[omil[n].typ].shotspeed)*(dst/mildsc[omil[n].typ].shotspeed); // s=1/2*a*t^2
//    if(i==0)newparticle(2, tgtx, tgty, tgtz);
    // Entfernung des Turm-Ziels
    dst=sqrt((omil[n].x-tgtx)*(omil[n].x-tgtx)
                  +(omil[n].y-tgty)*(omil[n].y-tgty));
    // Richtung des Ziels (Panzer)
    if(omil[omil[n].target].y-omil[n].y!=0){
      atot=atan((omil[n].x-omil[omil[n].ttarget].x)/(omil[omil[n].ttarget].y-omil[n].y));
    }else{
      atot=atan((omil[n].x-omil[omil[n].ttarget].x)/(1E-20));
    }
    if(omil[omil[n].target].y<omil[n].y)atot=atot+PI;
    // Richtung des Ziels (Turm)
    if(tgty-omil[n].y!=0){
      tatot=atan((omil[n].x-tgtx)/(tgty-omil[n].y));
    }else{
      tatot=atan((omil[n].x-tgtx)/(1E-20));
    }
    if(tgty<omil[n].y)tatot=tatot+PI;
    // Turm b-Richtung
    omil[n].tb=atan((omil[n].z-tgtz)/dst);
//    if(tgtz<omil[n].z)omil[n].tb+=PI;
    // begrenzen
    if(omil[n].tb>PI/4)omil[n].tb=PI/4;
    if(omil[n].tb<-0.17)omil[n].tb=-0.17;
    // Turm a-Richtung
    float posd=100, negd=100;
    if(tatot-(omil[n].ta)>=0&&tatot-(omil[n].ta)<posd)posd=tatot-(omil[n].ta);
    if((omil[n].ta)-tatot>0&&(omil[n].ta)-tatot<negd)negd=(omil[n].ta)-tatot;
    if(tatot-(omil[n].ta)+2*PI>=0&&tatot-(omil[n].ta)+2*PI<posd)posd=tatot-(omil[n].ta)+2*PI;
    if((omil[n].ta)-tatot+2*PI>0&&(omil[n].ta)-tatot+2*PI<negd)negd=(omil[n].ta)-tatot+2*PI;
    if(tatot-(omil[n].ta)-2*PI>=0&&tatot-(omil[n].ta)-2*PI<posd)posd=tatot-(omil[n].ta)-2*PI;
    if((omil[n].ta)-tatot-2*PI>0&&(omil[n].ta)-tatot-2*PI<negd)negd=(omil[n].ta)-tatot-2*PI;
    if(tatot-(omil[n].ta)+4*PI>=0&&tatot-(omil[n].ta)+4*PI<posd)posd=tatot-(omil[n].ta)+4*PI;
    if((omil[n].ta)-tatot+4*PI>0&&(omil[n].ta)-tatot+4*PI<negd)negd=(omil[n].ta)-tatot+4*PI;
    if(tatot-(omil[n].ta)-4*PI>=0&&tatot-(omil[n].ta)-4*PI<posd)posd=tatot-(omil[n].ta)-4*PI;
    if((omil[n].ta)-tatot-4*PI>0&&(omil[n].ta)-tatot-4*PI<negd)negd=(omil[n].ta)-tatot-4*PI;
    if(posd<negd){
//      omil[i].ta+=posd;
      omil[n].ta+=minf(gs.c*minf(1.0*TURRETTURNSPEED, posd*9), posd);
      taot=posd;
    }else{
//      omil[i].ta-=negd;
      omil[n].ta-=minf(gs.c*minf(1.0*TURRETTURNSPEED, negd*9), negd);
      taot=-negd;
    }
/*    float posd=100, negd=100;
    if(omil[n].atot-omil[n].a>0&&omil[n].atot-omil[n].a<posd)posd=omil[n].atot-omil[n].a;
    if(omil[n].a-omil[n].atot>0&&omil[n].a-omil[n].atot<negd)negd=omil[n].a-omil[n].atot;
    if(omil[n].atot-omil[n].a+2*PI>0&&omil[n].atot-omil[n].a+2*PI<posd)posd=omil[n].atot-omil[n].a+2*PI;
    if(omil[n].a-omil[n].atot+2*PI>0&&omil[n].a-omil[n].atot+2*PI<negd)negd=omil[n].a-omil[n].atot+2*PI;
    if(omil[n].atot-omil[n].a-2*PI>0&&omil[n].atot-omil[n].a-2*PI<posd)posd=omil[n].atot-omil[n].a-2*PI;
    if(omil[n].a-omil[n].atot-2*PI>0&&omil[n].a-omil[n].atot-2*PI<negd)negd=omil[n].a-omil[n].atot-2*PI;
    omil[n].da=0;
    if(posd<negd){
      omil[n].da=minf(0.6*TURNSPEED, posd*3);
      aott=posd;
    }else{
      omil[n].da=-minf(0.6*TURNSPEED, negd*3);
      aott=-negd;
    }*/
    if(taot<PI/32)shoot(n);
  }
}

void speed(void){
  struct timeb t2;
  ftime(&t2);
  float f2=0.001*(1000*t2.time+t2.millitm);
  gs.c=0.99*gs.c+0.01*(f2-gs.t);
  gs.g+=gs.c;
  gs.t=f2;
  // counter
  gs.cnt++;
}

void addfoot(int n){
  for(int i=-8;i<8;i+=2){
    addpixel(omil[n].x+0.45*cos(omil[n].a)+0.1*i*sin(omil[n].a), omil[n].y+0.45*sin(omil[n].a)-0.1*i*cos(omil[n].a));
    addpixel(omil[n].x-0.45*cos(omil[n].a)+0.1*i*sin(omil[n].a), omil[n].y-0.45*sin(omil[n].a)-0.1*i*cos(omil[n].a));
  }
  if(begr(rand(), 2)==0){
    newparticle(3, omil[n].x+0.45*cos(omil[n].a), omil[n].y+0.45*sin(omil[n].a), height(omil[n].x+0.45*cos(omil[n].a), omil[n].y+0.45*sin(omil[n].a)),1, false);
    newparticle(3, omil[n].x-0.45*cos(omil[n].a), omil[n].y-0.45*sin(omil[n].a), height(omil[n].x-0.45*cos(omil[n].a), omil[n].y-0.45*sin(omil[n].a)),1, false);
  }
}

void einschlag(float x, float y, int typ){
  if(typ!=3&&(typ!=-1||begr(rand(),2)==0)){
    for(int i=-4;i<=4;i++){
      for(int j=-4;j<=4;j++){
        if(sqrt(i*i+j*j)<=2){
          addpixel(x+(float)i/FXRES, y+(float)j/FYRES);
        }  
      }
    }
  }
  for(int i=-1;i<=1;i++){
    for(int j=-1;j<=1;j++){
      if(sqrt(i*i+j*j)<=1){
        addpixel(x+(float)i/FXRES, y+(float)j/FYRES);
      }  
    }
  }
  if(begr(rand(), 3)==0)newparticle(3, x, y, height(x, y), 1, false);
  addpixel(x, y);
/*  if(terra.hmap[begr(toint(x), FIELDX)][begr(toint(y), FIELDY)]>0){
    terra.hmap[begr(toint(x), FIELDX)][begr(toint(y), FIELDY)]--;
  }*/
}

void explode(int n){
  newparticle(1, omil[n].x, omil[n].y, omil[n].z-0.5, EXPSIZE, false);
  for(int i=0;i<EXPPARTS;i++){
    newparticle(1, omil[n].x+begrf(rand()/1000.0, 1), omil[n].y+begrf(rand()/1000.0, 1), omil[n].z-0.5+begrf(rand()/1000.0, 1), EXPSIZE*0.8-begrf(rand()/1000.0, EXPSIZE*0.6), false);
  }
  omil[n].used=false;
  omil[n].dead=true;
  for(int i=0;i<OMILS;i++){
    if(omil[i].target==n)omil[i].target=-1;
    if(omil[i].ttarget==n)omil[i].ttarget=-1;
  }
  for(int i=0;i<NUMSHOTS;i++){
    if(shot[i].tank==n)shot[i].tank=-1;
  }
  play(1);
/*  omil[n].owner=mission.omildesc[n].owner;
  omil[n].target=-1;
  omil[n].lastfoot=gs.g;
  omil[n].lastshot=gs.g;
  omil[n].typ=mission.omildesc[n].typ;
  omil[n].x=mission.omildesc[n].posx;
  omil[n].y=mission.omildesc[n].posy;
  omil[n].a=begrf(rand()*0.1,2*PI);
  omil[n].tb=PI/8;
  omil[n].hit=TANKHITPOINTS;
  omil[n].selected=false;*/
}

void panic(int n){
  float mindst=1E20;
  int ind=-1;
  for(int i=0;i<OMILS;i++){
    if(omil[i].used&&i!=n&&omil[i].owner!=omil[n].owner){
      float dst=(omil[i].x-omil[n].x)*(omil[i].x-omil[n].x)
               +(omil[i].y-omil[n].y)*(omil[i].y-omil[n].y);
      if(dst<mindst){
        mindst=dst;
        ind=i;
      }
    }
  }
  if(ind!=-1){
    attack(n, ind);
  }
}

void checkhit(int n, int s){
  if(absf(omil[n].x-shot[s].x)<0.6&&absf(omil[n].y-shot[s].y)<0.6&&absf(omil[n].z-shot[s].z)<0.50&&(shot[s].owner!=omil[n].owner||shot[s].typ==-1)){
    if(shot[s].tank!=-1){
      omil[shot[s].tank].hitting=true;
    }
    if(omil[n].owner!=0&&omil[n].target==-1&&omil[n].ttarget==-1&&shot[s].tank!=-1){
      panic(n);
    }
/*    if(omil[n].ttarget==-1&&shot[s].tank!=-1)omil[n].ttarget=shot[s].tank;*/
    omil[n].hit-=mildsc[shot[s].typ==-1?2:shot[s].typ].shothit;
    killshot(s);
    if(shot[s].typ!=3||begr(rand(), 10)==0)newparticle(1, shot[s].x, shot[s].y, shot[s].z-0.5, 1.3-begrf(rand()/1000.0, 1.0), false);
    if(omil[n].hit<0){
      explode(n);
    }
  }
}

void calcomil(int i){
  startprofile(8);
  // fahren
  omil[i].x-=sin(omil[i].a)*omil[i].sp*gs.c;
  omil[i].y+=cos(omil[i].a)*omil[i].sp*gs.c;
  // drehen
  omil[i].a+=omil[i].da*gs.c;
  // z-position
  omil[i].z=height(omil[i].x, omil[i].y)-0.35;
  // b, c
  omil[i].b=atan((height(omil[i].x+0.88*sin(omil[i].a), omil[i].y-0.88*cos(omil[i].a))-height(omil[i].x-0.88*sin(omil[i].a), omil[i].y+0.88*cos(omil[i].a)))*0.568);
  omil[i].c=atan((height(omil[i].x-0.66*cos(omil[i].a), omil[i].y-0.66*sin(omil[i].a))-height(omil[i].x+0.66*cos(omil[i].a), omil[i].y+0.66*sin(omil[i].a)))*0.757);
  // a, ta auf 2*PI begrenzen
  omil[i].a=begrf(omil[i].a, 2*PI);
  omil[i].ta=begrf(omil[i].ta, 2*PI);
  stopprofile(8);
  startprofile(9);
  ki(i);
  stopprofile(9);
  startprofile(10);
  if((omil[i].sp!=0&&omil[i].da!=0)&&gs.g>omil[i].lastfoot+0.6/TANKSPEED){
    omil[i].lastfoot=gs.g;
    addfoot(i);
  }
  stopprofile(10);
}

void calccol(void){
  float xdst;
  float ydst;
  float dstsq;
  for(int i=0;i<OMILS;i++){
    if(omil[i].used||omil[i].dead){
      for(int j=0;j<OMILS;j++){
        if(omil[j].used&&i!=j){
          xdst=omil[i].x-omil[j].x;
          ydst=omil[i].y-omil[j].y;
          float size;
          size=mildsc[omil[i].typ].size+mildsc[omil[j].typ].size;
          dstsq=(xdst*xdst+ydst*ydst);
          if(dstsq<size){
            if(omil[i].target==j)omil[i].hitting=true;
            if(omil[j].target==i)omil[j].hitting=true;
/*            omil[i].hit-=2;
            omil[j].hit-=2;*/
            if(xdst<ydst){
              ydst=1;
              if(ydst!=0)xdst/=ydst;
            } else {
              xdst=1;
              if(xdst!=0)ydst/=xdst;
            }
            omil[i].x+=1.0*gs.c*xdst;
            omil[i].y+=1.0*gs.c*ydst;
            omil[j].x-=1.0*gs.c*xdst;
            omil[j].y-=1.0*gs.c*ydst;
/*            omil[i].x+=sin(omil[i].a)*omil[i].sp*gs.c;
            omil[i].y-=cos(omil[i].a)*omil[i].sp*gs.c;
            omil[j].x+=sin(omil[j].a)*omil[j].sp*gs.c;
            omil[j].y-=cos(omil[j].a)*omil[j].sp*gs.c;*/
          }
        }
      }
    }
  }
}

void calctreecol(void){
//  float xdst, ydst, dstsq;
  for(int i=0;i<OMILS;i++){
    if(omil[i].used){
      for(int j=0;j<TREES;j++){
        if(tree[j].used&&!tree[j].falling){
/*          xdst=omil[i].x-tree[j].x;
          ydst=omil[i].y-tree[j].y;
          dstsq=(xdst*xdst+ydst*ydst);*/
          if(absf(omil[i].x-tree[j].x)<mildsc[omil[i].typ].size&&absf(omil[i].y-tree[j].y)<mildsc[omil[i].typ].size){
/*            if(xdst<ydst){
              ydst=1;
              if(ydst!=0)xdst/=ydst;
            } else {
              xdst=1;
              if(xdst!=0)ydst/=xdst;
            }
            omil[i].x+=0.15*gs.c*xdst;
            omil[i].y+=0.15*gs.c*ydst;
            omil[i].x+=sin(omil[i].a)*omil[i].sp*gs.c;
            omil[i].y-=cos(omil[i].a)*omil[i].sp*gs.c;*/
            // Baum fllt tot um
            if(omil[i].sp>=0){
              tree[j].a=omil[i].a;
            } else {
              tree[j].a=omil[i].a+PI;
            }
            tree[j].falling=true;
          }
        }
      }
    }
  }
}

void calcsuccess(void){
  int friends=0, foes=0;
  for(int i=0;i<OMILS;i++){
    if(omil[i].used){
      if(omil[i].owner==0)friends++;
      if(omil[i].owner==1)foes++;
    }
  }
  bool success=true, fail=false;
/*  int survive, kill;
  bool killall, location, killlocation;
  float gotox, gotoy, radius;
  float killx, killy, killradius;*/
  if(mission.goal.killall&&foes!=0)success=false;
  if(mission.goal.kill!=-1&&omil[mission.goal.kill].used)success=false;
  if(mission.goal.location){
    for(int i=0;i<OMILS;i++){
      if(omil[i].used&&omil[i].owner==0){
        if(sqrt((omil[i].x-mission.goal.gotox)*(omil[i].x-mission.goal.gotox)
               +(omil[i].y-mission.goal.gotoy)*(omil[i].y-mission.goal.gotoy))>=mission.goal.radius){
          success=false;
        }
      }
    }
  }
  if(mission.goal.killlocation){
    for(int i=0;i<OMILS;i++){
      if(omil[i].used&&omil[i].owner!=0){
        if(sqrt((omil[i].x-mission.goal.killx)*(omil[i].x-mission.goal.killx)
               +(omil[i].y-mission.goal.killy)*(omil[i].y-mission.goal.killy))<mission.goal.killradius){
          success=false;
        }
      }
    }
  }
  if(mission.goal.ban){
    for(int i=0;i<OMILS;i++){
      if(omil[i].used&&omil[i].owner!=0){
        if(sqrt((omil[i].x-mission.goal.banx)*(omil[i].x-mission.goal.banx)
               +(omil[i].y-mission.goal.bany)*(omil[i].y-mission.goal.bany))<mission.goal.banradius){
          success=false;
          fail=true;
        }
      }
    }
  }
  if(friends==0){success=false;fail=true;}
  if(mission.goal.survive!=-1){
    if(!omil[mission.goal.survive].used){fail=true;success=false;}
  }
  if(success||fail){
    if(success){
      mission.success=true;
      if(strlen(mission.next)!=0)strcpy(mission.fname, mission.next);
    } else {
      mission.success=false;
    }
    mission.done=true;
    displaymenu(2);
    view.timemenu=true;
    view.menukilltime=gs.g+2;
//    gameinit();
  }
}

void calctrees(void){
  for(int i=0;i<TREES;i++){
    if(tree[i].used&&tree[i].falling){
      tree[i].b+=2*gs.c;
      if(tree[i].b>0.5*PI)tree[i].b=0.5*PI;
    }
  }
}

void calcmenu(void){
  if(view.menu&&view.timemenu&&gs.g>view.menukilltime){
    if(view.menutype==2){
      view.timemenu=false;
      killgame();
      gameinit();
    }
  }
}

void calculate(void){
  status(100);
  speed();
  calcmenu();
  status(101);
  calctrees();
  for(int i=0;i<OMILS;i++){
    if(omil[i].used){
      calcomil(i);
    }
  }
  startprofile(0);
  if(!mission.done)calcsuccess();
  calccol();
  calctreecol();
  status(106);
  stopprofile(0);
  startprofile(1);
  tparticle swap;
  for(int i=0;i<PARTICLES;i++){
    if(part[i].used){
      float plife=(part[i].typ==3?PARTICLELIFE3:PARTICLELIFE);
      if(gs.g-part[i].t>=plife){
        status(107);
        killparticle(i);
        status(108);
      } else {
        part[i].z=part[i].z+part[i].dz;
        if(i+1<PARTICLES&&part[i+1].used){
          if(part[i].z<part[i+1].z){
            swap=part[i];
            part[i]=part[i+1];
            part[i+1]=swap;
          }
        }
        if(gs.g-part[i].t>PARTICLELIFE*EXPLFIRE&&part[i].lit&&part[i].typ==1)removelight(i);
        if(part[i].lit){
          // lighting
          dxlight=partlight(i);
          dxd3ddevice->SetLight(PARTLIGHTOFFSET+i, &dxlight);
//          dxd3ddevice->SetLight(PARTLIGHTOFFSET+i, NULL);
//          dxd3ddevice->LightEnable(PARTLIGHTOFFSET+i, FALSE);
        }
      }
    }
  }
  stopprofile(1);
  startprofile(2);
  status(114);
  for(int i=0;i<NUMSHOTS;i++){
    if(shot[i].used){
      shot[i].x+=shot[i].dx*gs.c;
      shot[i].y+=shot[i].dy*gs.c;
      shot[i].z+=shot[i].dz*gs.c;
      if(shot[i].typ==2&&gs.g-shot[i].lastsmoke>=0.08){
        newparticle(3, shot[i].x, shot[i].y, shot[i].z, 1, false);
        shot[i].lastsmoke=gs.g;
      }
      shot[i].dz+=SHOTGRAVITY*gs.c;
      if(gs.g-shot[i].t>5){
        if(shot[i].tank!=-1)omil[shot[i].tank].hitting=false;
        killshot(i);
        status(116);
        continue;
      }
      if(height(shot[i].x,shot[i].y)<shot[i].z){
        if(shot[i].tank!=-1)omil[shot[i].tank].hitting=false;
        einschlag(shot[i].x, shot[i].y, shot[i].typ);
        killshot(i);
        continue;
      }
      if(shot[i].split!=-1&&shot[i].split<gs.g){
        int num=0;
        for(int j=0;j<NUMSHOTS;j++){
          if(!shot[j].used){
            num++;
            shot[j]=shot[i];
            shot[j].typ=-1;
            shot[j].split=-1;
            shot[j].dx+=(begr(rand(), 100)-50)*0.04;
            shot[j].dy+=(begr(rand(), 100)-50)*0.04;
            shot[j].dz+=(begr(rand(), 100)-50)*0.04;
          }
          if(num>=10)break;
        }
        shot[i].used=false;
        continue;
      }
#ifndef DISABLESHOTLIGHTING
      // lighting
      dxlight=shotlight(i);
      dxd3ddevice->SetLight(SHOTLIGHTOFFSET+i, &dxlight);
//      dxd3ddevice->LightEnable(SHOTLIGHTOFFSET+i, TRUE);
#endif
      for(int j=0;j<OMILS;j++){
        if(omil[j].used)checkhit(j, i);// der shot knnte danach nicht mehr existieren
      }
    }
  }
  startprofile(2);
  status(126);
}

void LoadDirectSound(LPDIRECTSOUNDBUFFER *buffer,char* filename)
{
    FILE *f;
    f=fopen(filename, "rb");
    fseek(f, 0, SEEK_END);
    int flen=ftell(f);
    fseek(f, 0, SEEK_SET);
    status(908);

    PCMWAVEFORMAT pcmwf; 
    DSBUFFERDESC dsbdesc; 
    HRESULT hr; 
    // Set up wave format structure. 
    memset(&pcmwf, 0, sizeof(PCMWAVEFORMAT)); 
    pcmwf.wf.wFormatTag = WAVE_FORMAT_PCM; 
    pcmwf.wf.nChannels = 1; 
    pcmwf.wf.nSamplesPerSec = 8000; 
    pcmwf.wf.nBlockAlign = 1; 
    pcmwf.wf.nAvgBytesPerSec = 
        pcmwf.wf.nSamplesPerSec * pcmwf.wf.nBlockAlign; 
    pcmwf.wBitsPerSample = 8; 
    // Set up DSBUFFERDESC structure. 
    memset(&dsbdesc, 0, sizeof(DSBUFFERDESC)); // Zero it out. 
    dsbdesc.dwSize = sizeof(DSBUFFERDESC); 
    // Need default controls (pan, volume, frequency). 
    dsbdesc.dwFlags = DSBCAPS_CTRLPAN | DSBCAPS_CTRLVOLUME | DSBCAPS_CTRLFREQUENCY; 
    // buffer. 
    dsbdesc.dwBufferBytes = flen;//3 * pcmwf.wf.nAvgBytesPerSec; 
    dsbdesc.lpwfxFormat = (LPWAVEFORMATEX)&pcmwf; 
    // Create buffer. 
    dxsound->CreateSoundBuffer(&dsbdesc, buffer, NULL); 

/*	WAVEFORMATEX wavefmt;
 	wavefmt.wFormatTag=0;
	wavefmt.nChannels=1;
	wavefmt.nSamplesPerSec=11025;
	wavefmt.nAvgBytesPerSec=11025;
	wavefmt.nBlockAlign=8192;
	//create a directsound buffer to hold wave data
	DSBUFFERDESC bufdesc;
	memset(&bufdesc,0,sizeof(DSBUFFERDESC));
	bufdesc.dwSize = sizeof(DSBUFFERDESC);
	bufdesc.dwFlags = DSBCAPS_PRIMARYBUFFER;//DSBCAPS_CTRLDEFAULT;
	bufdesc.dwBufferBytes = flen;
	bufdesc.lpwfxFormat = &wavefmt;
    status(909);
	dxsound->CreateSoundBuffer(&bufdesc,&(*buffer),NULL);*/
    status(910);
	//write wave data to directsound buffer you just created
	void *write1=NULL;
	unsigned long length1;
    status(911);
	(*buffer)->Lock(0,flen,&write1,&length1,NULL,NULL,DSBLOCK_ENTIREBUFFER );
    status(912);
    status(913);
    fread(write1,length1, 1, f);
    status(914);
    fclose(f);
    status(915);
	(*buffer)->Unlock(write1,length1,0,0);
    status(916);
}

void loadsounds(void)
{
  LoadDirectSound(&dxsoundbuffer[0*PARSOUNDS],"bumm.wav");
  for(int i=1;i<PARSOUNDS;i++)dxsound->DuplicateSoundBuffer(dxsoundbuffer[0],&dxsoundbuffer[i]);
  LoadDirectSound(&dxsoundbuffer[1*PARSOUNDS],"expl.wav");
  for(int i=1;i<PARSOUNDS;i++)dxsound->DuplicateSoundBuffer(dxsoundbuffer[PARSOUNDS],&dxsoundbuffer[PARSOUNDS+i]);
  LoadDirectSound(&dxsoundbuffer[2*PARSOUNDS],"mg.wav");
  for(int i=1;i<PARSOUNDS;i++)dxsound->DuplicateSoundBuffer(dxsoundbuffer[2*PARSOUNDS],&dxsoundbuffer[2*PARSOUNDS+i]);
  LoadDirectSound(&dxsoundbuffer[3*PARSOUNDS],"art.wav");
  for(int i=1;i<PARSOUNDS;i++)dxsound->DuplicateSoundBuffer(dxsoundbuffer[3*PARSOUNDS],&dxsoundbuffer[3*PARSOUNDS+i]);
}

void dsoundinit()
{
	//get directsound interface
    status(903);
	DirectSoundCreate(NULL,&dxsound,NULL);
    status(904);
	//setcooperativelevel of interface
    status(905);
	dxsound->SetCooperativeLevel(hwnd,DSSCL_NORMAL);
    status(906);
    loadsounds();
    status(907);
}

void dsoundshutdown(void){
  for(int i=0;i<SOUNDS;i++){
    if(dxsoundbuffer[i]!=NULL)dxsoundbuffer[i]->Release();
  }
  if(dxsound!=NULL)dxsound->Release();
}

void mildscinit(void){
  mildsc[0].maxspeed=TANKSPEED;
  mildsc[0].shotspeed=SHOTSPEED;
  mildsc[0].size=1.2;
  mildsc[0].range=20;
  mildsc[0].shothit=5;
  mildsc[0].hitpoints=200;
  mildsc[0].shotfreq=1;
  mildsc[1].maxspeed=1.2*TANKSPEED;
  mildsc[1].shotspeed=0.8*SHOTSPEED;
  mildsc[1].size=1.0;
  mildsc[1].range=15;
  mildsc[1].shothit=3;
  mildsc[1].hitpoints=120;
  mildsc[1].shotfreq=0.6;
  mildsc[2].maxspeed=0.6*TANKSPEED;
  mildsc[2].shotspeed=1.5*SHOTSPEED;
  mildsc[2].size=2;
  mildsc[2].range=30;
  mildsc[2].shothit=3;
  mildsc[2].hitpoints=120;
  mildsc[2].shotfreq=1.5;
  mildsc[3].maxspeed=1.4*TANKSPEED;
  mildsc[3].shotspeed=2*SHOTSPEED;
  mildsc[3].size=0.8;
  mildsc[3].range=20;
  mildsc[3].shothit=1;
  mildsc[3].hitpoints=100;
  mildsc[3].shotfreq=0.1;
  mildsc[4].maxspeed=1.3*TANKSPEED;
  mildsc[4].shotspeed=2*SHOTSPEED;
  mildsc[4].size=0.7;
  mildsc[4].range=20;
  mildsc[4].shothit=1;
  mildsc[4].hitpoints=100;
  mildsc[4].shotfreq=3;
  mildsc[5].maxspeed=1.2*TANKSPEED;
  mildsc[5].shotspeed=2*SHOTSPEED;
  mildsc[5].size=0.7;
  mildsc[5].range=20;
  mildsc[5].shothit=1;
  mildsc[5].hitpoints=100;
  mildsc[5].shotfreq=3;
  mildsc[6].maxspeed=1.2*TANKSPEED;
  mildsc[6].shotspeed=2*SHOTSPEED;
  mildsc[6].size=0.7;
  mildsc[6].range=20;
  mildsc[6].shothit=1;
  mildsc[6].hitpoints=100;
  mildsc[6].shotfreq=3;
  mildsc[7].maxspeed=1.4*TANKSPEED;
  mildsc[7].shotspeed=2*SHOTSPEED;
  mildsc[7].size=0.7;
  mildsc[7].range=20;
  mildsc[7].shothit=1;
  mildsc[7].hitpoints=100;
  mildsc[7].shotfreq=3;
}

int WINAPI WinMain(HINSTANCE hThisInstance, HINSTANCE hPrevInstance, LPSTR lpszArgument, int nFunsterStil){
  status(1);
  status(1100);
  if(!wininit(hThisInstance))winerror();
  status(1101);
  status(2);
  status(1102);
  dxinit();
  status(1103);
  status(1104);
  mildscinit();
  status(1105);
  status(900);
  dsoundinit();
  status(901);
  status(902);
  status(3);
  status(4);
  strcpy(mission.fname, "t3_1way.mis");
  gameinit();
  status(5);
  // render
  while ( !bQuit ) {
    if ( PeekMessage( &messages, NULL, 0, 0, PM_REMOVE ) ) {
      status(6);
      if ( messages.message == WM_QUIT ) {
        status(7);
        bQuit=TRUE;
      } else {
        status(8);
        TranslateMessage( &messages );
        DispatchMessage( &messages );
      }
    } else {
      status(9);
      input();
      status(10);
      calculate();
      status(11);
      render();
      status(12);
    }
  }  
  status(13);
  killgame();
  dsoundshutdown();
  dxcleanup();
  status(14);
  DestroyWindow(hwnd);
  status(15);
  return 0;
}

